local log = require "log"

enDialogTitleH       = 22

----------------------------------------------------------

---- Layout

local rowH        = 26
local rowSep      = 3
local elementSep  = 10
local textPadding = 6

local EPG_layout = {
	  header = {
		  x = safe_x
		, y = safe_y
		, width  = safe_w
		, height = rowH
		, bg_color = Blue
	}
	, current_video = {}
	
	, schedule = {
	  	  x = safe_x
		, y = safe_y + rowH + elementSep + rowH + rowSep + rowH + rowSep + 45 + rowSep + 106 + elementSep
	  	, width  = safe_w
	  	, height = 170
	  	, row_height = 20

		, visible_channels = 6
		, visible_slots = 3
		, channel_width = 150
		, max_days = 3
		, slot_minutes = 30

		, scrollbar = {
			width = 20
		}		
	}

	, footer = {
	}
}


local EPGView = {
	  view = nil
	, time = nil
	, show_description = {
		  channel = {
			  logo   = nil
			, number = nil
			, name   = nil
		}
		, fav     = nil
		, blocked = nil
		, parental_content = nil
		, parental_age     = nil
		, name        = nil
		, description = nil
	}
	, current_video = {
		  frame = nil
		, title = nil
	}

	, footer = nil
}

local EPGColorTable = {  
			bgColor = Color.None,
			bgLabelColor = Color.None,
			borderColor = Color.Blue,
			textColor = Color.White
		  }

local EPGHeaderColorTable = {  
			bgColor = Color.Blue,
			bgLabelColor = Color.Blue,
			borderColor = Color.Blue,
			textColor = Color.White
		  }

local EPGTextAreaColorTable = {  
			bgColor = Color.DarkBlue,
			bgLabelColor = Color.Blue,
			borderColor = Color.Blue,
			textColor = Color.White
		  }
		  
local colorTableSchedule = { 
			bgColor = Color.None,
			borderColor = Color.None,
			bgLabelColor = Color.None,
			selectedColor = Color.Yellow, 
			disabledColor = Color.Gray2,
			textColor = Color.White,
			selectedTextColor = Color.Black,
			cellColor = Color.DarkBlue,
			selectedCellColor = Color.White,
			headerColor = Color.Blue,
			textHeaderColor = Color.White
		     }

function EPGView.create()
	EPGView.view = window:new(safe_x,safe_y, safe_w,safe_h, menuZIndex, EPGColorTable)

-- Header
	local header_window = window:new(safe_x,safe_y, safe_w,rowH, menuZIndex, EPGHeaderColorTable)
	local title  = label:new(safe_x, safe_y, safe_w,rowH, EPGColorTable, "GUÍA DE PROGRAMACIÓN", 16, Alignment.vBottom_hLeft, textPadding)
	local currentTime = mainWindow.getTime('%d/%m/%Y - %H:%Mhs')
	EPGView.time = label:new(safe_x + safe_w/2,safe_y, safe_w/2 - textPadding,rowH, EPGHeaderColorTable, currentTime, 16, Alignment.vBottom_hRight, textPadding)

	window:addChild(header_window, title)
	window:addChild(header_window, EPGView.time)
	window:addChild(EPGView.view, header_window)

-- Show Description
	local descriptionX = safe_x + 240 + elementSep
	local descriptionY = safe_y + rowH + elementSep

	EPGView.show_description.channel.logow    =   window:new(descriptionX,                           descriptionY,                  55, 55, menuZIndex, EPGHeaderColorTable)
	EPGView.show_description.channel.logo     =    image:new(descriptionX + 5,                       descriptionY + 5, 45, 45, menuZIndex, EPGHeaderColorTable, "INFO_logoCanal.png")
	EPGView.show_description.channel.number   =    label:new(descriptionX + 2*rowH + 2*rowSep,       descriptionY,                  96,                  rowH, EPGHeaderColorTable, "", 16, Alignment.vBottom_hLeft, textPadding)
	EPGView.show_description.channel.name     = textarea:new(descriptionX + 2*rowH + 2*rowSep,       descriptionY + rowH + rowSep, 116 + 4*(rowSep +35), rowH, EPGHeaderColorTable, "", 17, 1, textPadding, Alignment.vCenter_hLeft)
	EPGView.show_description.favw             =   window:new(descriptionX + 2*rowH + 3*rowSep +  96, descriptionY,                  38, rowH, menuZIndex, EPGHeaderColorTable)
	EPGView.show_description.fav              =    image:new(descriptionX + 2*rowH + 3*rowSep +  96 + (38-24)/2, descriptionY + (rowH-20)/2, 24, 20, menuZIndex, EPGHeaderColorTable, "Canales_Favorito_Blanco.png")
	EPGView.show_description.blockedw         =   window:new(descriptionX + 2*rowH + 4*rowSep + 134, descriptionY,                  38, rowH, menuZIndex, EPGHeaderColorTable)
	EPGView.show_description.blocked          =    image:new(descriptionX + 2*rowH + 4*rowSep + 134 + (38-24)/2, descriptionY + (rowH-20)/2, 24, 20, menuZIndex, EPGHeaderColorTable, "Canales_Bloquear_Blanco.png")
	EPGView.show_description.parental_content =    label:new(descriptionX + 2*rowH + 5*rowSep + 172, descriptionY, 42, rowH, EPGHeaderColorTable, "", 14, Alignment.vBottom_hCenter, textPadding)
	EPGView.show_description.parental_age     =    label:new(descriptionX + 2*rowH + 6*rowSep + 214, descriptionY, 42, rowH, EPGHeaderColorTable, "", 14, Alignment.vBottom_hCenter, textPadding)
	EPGView.show_description.name             = textarea:new(descriptionX, descriptionY + 2*rowH + 2*rowSep,      55 + rowSep + 104 + 4*(rowSep +38),  45, EPGTextAreaColorTable, "", 14, 2, textPadding, Alignment.vBottom_hLeft)
	EPGView.show_description.description      = textarea:new(descriptionX, descriptionY + 2*rowH + 3*rowSep + 45, 55 + rowSep + 104 + 4*(rowSep +38), 106, EPGTextAreaColorTable, "", 14, 5, textPadding, Alignment.vBottom_hLeft)

	window:addChild(EPGView.show_description.channel.logow, EPGView.show_description.channel.logo)
	window:addChild(EPGView.show_description.favw,          EPGView.show_description.fav)
	window:addChild(EPGView.show_description.blockedw,      EPGView.show_description.blocked)

	window:addChild(EPGView.view, EPGView.show_description.channel.logow)
	window:addChild(EPGView.view, EPGView.show_description.channel.number)
	window:addChild(EPGView.view, EPGView.show_description.channel.name)
	window:addChild(EPGView.view, EPGView.show_description.favw)
	window:addChild(EPGView.view, EPGView.show_description.blockedw)
	window:addChild(EPGView.view, EPGView.show_description.parental_content)
	window:addChild(EPGView.view, EPGView.show_description.parental_age)
	window:addChild(EPGView.view, EPGView.show_description.name)
	window:addChild(EPGView.view, EPGView.show_description.description)

-- Resized video of the current show
	local video_frame_h = rowH + rowSep + rowH + rowSep + 45 + rowSep + 106
	EPG_layout.current_video = {
			  x = safe_x + rowSep
			, y = safe_y + rowH + elementSep + rowSep
			, width  = 240 - 2*rowSep
			, height = rowH + rowSep + rowH + rowSep + 45 + rowSep + 106 - 20 - 2*rowSep
	}
	current_video_frame = window:newFrame(safe_x, safe_y + rowH + elementSep, 240, video_frame_h
	                                    , EPG_layout.current_video.x, EPG_layout.current_video.y, EPG_layout.current_video.width, EPG_layout.current_video.height
	                                    , EPGHeaderColorTable)
	EPGView.current_video.title = textarea:new(safe_x, safe_y + rowH + elementSep + video_frame_h + 4 - rowH, EPG_layout.current_video.width, rowH, EPGColorTable, "", 14, 1, textPadding, Alignment.vBottom_hLeft)
	window:addChild(current_video_frame, EPGView.current_video.title)
	window:addChild(EPGView.view, current_video_frame)

-- Schedule
	local schedule_x = safe_x
	local schedule_y = safe_y + rowH + elementSep + rowH + rowSep + rowH + rowSep + 45 + rowSep + 106 + elementSep
	local schedule_width  = safe_w + 4
	local schedule_height = 170
	local schedule_row_height = 20

	EPGView.schedule_window = schedule:new(schedule_x-1,schedule_y, schedule_width, schedule_height, colorTableSchedule)
	schedule:setRowHeight(EPGView.schedule_window, schedule_row_height)
	schedule:setWidths(   EPGView.schedule_window, 150, 133)
	schedule:setRowSep(   EPGView.schedule_window, rowSep)
	schedule:setShowSelectedCallback(   EPGView.schedule_window, "showSelected")
	schedule:setChannelSelectedCallback(EPGView.schedule_window, "channelSelected")
	schedule:setMoreShowsCallback(EPGView.schedule_window, "needMoreShows")

	window:addChild(EPGView.view, EPGView.schedule_window)

-- Footer
	EPGView.footer = label:new(safe_x, safe_y + (safe_h - rowH), safe_w, rowH, EPGHeaderColorTable, "", 14, Alignment.vBottom_hLeft, textPadding)
	window:addChild(EPGView.view, EPGView.footer)

	wgt:setVisible(EPGView.view, FALSE)
end

EPGView.create()

---- Rendering

function EPG_layout.current_video.render()
	if channel.current() ~= -1 then
		local channel = channels.get(channel.current())
		textarea:setText(EPGView.current_video.title, 'Estás viendo: '.. channel.channel .. ' - ' ..channel.name)
	else
		textarea:setText(EPGView.current_video.title, '')
	end	
	-- print('[lua] Resizing video to fit into: x='..EPG_layout.current_video.x..', y='..EPG_layout.current_video.y.. ', w='..EPG_layout.current_video.width..', h='..EPG_layout.current_video.height)
	channel.resize(EPG_layout.current_video.x, EPG_layout.current_video.y, EPG_layout.current_video.width, EPG_layout.current_video.height)
end

function EPG_layout.current_video.hide()
	channel.setFullScreen()
end

function renderEPG()
	EPG_layout.footer.update()
	
	EPG_layout.current_video.render()
	
	Timers.currentTime.action = oneMinute
	local tID = mainWindow.registerTimer(Timers.currentTime.timeout)
	Timers.currentTime.id = tID
end

function hideEPG()
	mainWindow.cancelTimer(Timers.currentTime.id)
	EPG_layout.current_video.hide()
end

function EPG_layout.footer.update()
	local ch = EPG.schedule.selectedChannel()
	if (ch and channel.current() == ch.id) then
		label:setText(EPGView.footer, 'EXIT = Salir')
	else
		label:setText(EPGView.footer, 'OK = Cambia al canal seleccionado  EXIT = Salir')
	end
end

local ShowBlockedChannels = false

-- Data

EPG = {
	  name= 'EPG'
	, show_description = {
	}
	
	, schedule = {
		  channels = {
			    showsByTime = {
--				  {name = '', startTime='', stopTime=''}
			    } -- end shows of channel
			    , showsByIndex = {
			    } -- end shows of channel (lo mismo pero con otro orden)
		} -- end channels
		, channels_indices = {}
		, selected_channel = 1
		, selected_show    = 1
	}
	, visible=false
	, ignoredKeys = {}
}

function getCurrentDate(dayOffset)
--	return '2011-05-02'
	return mainWindow.getDatePlus('%Y-%m-%d', dayOffset)
end

function getFullTime()
--	return '2011-05-02 16:16'
	return mainWindow.getTime('%Y-%m-%d %H:%M')
end

function getVisibleShows(channelID, time_from, time_to)
	if not time_from then
		time_from, time_to = schedule:getVisibleTimeRange(EPGView.schedule_window)
	end
	log.debug( "EPG", "getVisibleShows", "id="..channelID .. ", from="..time_from..", to="..time_to)

	local channelIx = EPG.schedule.channels_indices[channelID]
	if channelIx then -- can be a One-Seg channel when they aren't visible
		local channel = channels.get(channelID)
		if canShowChannelData(channel) then -- only get data for unblocked channels
			local shows = channels.getShowsBetween( channel.channelID, time_from, time_to )
			for _,show in ipairs(shows) do
				log.debug( "EPG", "getVisibleShows", channel.name..", "..show.name.. ", " .. show.description .. " (".. fullTime(show.startDate) .. " - ".. fullTime(show.stopDate) ..")")
				if not EPG.schedule.channels[channelIx].showsByTime[fullTime(show.startDate)] then
					-- print('[lua]     added')
					EPG.schedule.channels[channelIx].showsByTime[fullTime(show.startDate)] = show
					table.insert(EPG.schedule.channels[channelIx].showsByIndex, show)
					
					schedule:addCell(EPGView.schedule_window, channelIx-1, fullTime(show.startDate)..":00", fullTime(show.stopDate)..":00", show.name, #EPG.schedule.channels[channelIx].showsByIndex)
				end
			end

		end -- end not blocked
	end
end


-- Data filling
function fillEPG()
	EPG.schedule.fill(true)
	EPG.show_description.clear() -- clear any previous data
	EPG.show_description.fill()
end

function EPG.acceptsFocus()
	return true
end

function canShowChannelData(channel)
	return channels.isProtected(channel.channelID)==FALSE or ShowBlockedChannels
end

function EPG.schedule.selectedChannel()
	return EPG.schedule.channels[EPG.schedule.selected_channel]
end

function EPG.show_description.fill()
--	print('[lua] EPG.show_description.fill')
	local channel = EPG.schedule.selectedChannel()
	if channel then
--		print('[lua] EPG.show_description.fill, id='..channel.id)
		local chInfo = channels.getInfo(channel.id)

		if canShowChannelData(chInfo) then
			wgt:setVisible(EPGView.show_description.channel.logo, TRUE)
			textarea:setText(EPGView.show_description.channel.name, chInfo.name)
		else
			wgt:setVisible(EPGView.show_description.channel.logo, FALSE)
			textarea:setText(EPGView.show_description.channel.name, '')
		end		
		label:setText(EPGView.show_description.channel.number, chInfo.channel)
		
		wgt:setVisible(EPGView.show_description.fav,     chInfo.favorite)
		wgt:setVisible(EPGView.show_description.blocked, chInfo.blocked)
		wgt:repaint(EPGView.show_description.favw)
		wgt:repaint(EPGView.show_description.blockedw)
		label:setText(EPGView.show_description.parental_content, chInfo.parentalContent)
		label:setText(EPGView.show_description.parental_age,     chInfo.parentalAge)

--		print('[lua] EPG.show_description.fill, selected_show:' .. EPG.schedule.selected_show .. ' out of '.. #EPG.schedule.selectedChannel().showsByIndex)
		if (0 < EPG.schedule.selected_show and EPG.schedule.selected_show <= #EPG.schedule.selectedChannel().showsByIndex) and canShowChannelData(chInfo) then
			local show = EPG.schedule.selectedChannel().showsByIndex[EPG.schedule.selected_show]
--			print('[lua] EPG.show_description.fill, canShow, show='.. show.name ..', description='.. show.description)
			textarea:setText(EPGView.show_description.name, show.name .. ', ' .. show.startDate.time .. ' a ' .. show.stopDate.time)
			textarea:setText(EPGView.show_description.description, show.description)
		else
			textarea:setText(EPGView.show_description.name, '')
			textarea:setText(EPGView.show_description.description, '')
		end
	end
end

function EPG.show_description.clear()
--	print('[lua] EPG.show_description.clear')
	wgt:setVisible(EPGView.show_description.channel.logo, FALSE)
	label:setText(EPGView.show_description.channel.number, '')
	textarea:setText(EPGView.show_description.channel.name, '')
	wgt:setVisible(EPGView.show_description.fav,     FALSE)
	wgt:setVisible(EPGView.show_description.blocked, FALSE)
	wgt:repaint(EPGView.show_description.favw)
	wgt:repaint(EPGView.show_description.blockedw)
	label:setText(EPGView.show_description.parental_content, '')
	label:setText(EPGView.show_description.parental_age,     '')
	textarea:setText(EPGView.show_description.name, '')
	textarea:setText(EPGView.show_description.description, '')
end

function EPG.schedule.fill(initial)
--	print('[lua] EPG.schedule.fill')
	label:setText(EPGView.time, mainWindow.getTime('%d/%m/%Y - %H:%Mhs'))
	local chCount = 0
	local currentTime = getFullTime()
	if (initial) then
		EPG.schedule.channels = {}
		EPG.schedule.selected_channel = 1
		local titles = {}
		for _,ch in ipairs(channels.getAll()) do
			if canShowChannelData(ch) then
				chCount = chCount + 1
				EPG.schedule.channels[chCount] = {
					   showsByTime = {}
					 , showsByIndex = {}
					 , id = ch.channelID
				}
				EPG.schedule.channels_indices[ch.channelID] = chCount
				
				if channel.current() == ch.channelID then
					EPG.schedule.selected_channel = chCount
				end

				table.insert(titles, ch.name)
			end
		end

		schedule:initSlots(EPGView.schedule_window, currentTime, EPG_layout.schedule.slot_minutes, 60*24*EPG_layout.schedule.max_days/EPG_layout.schedule.slot_minutes)
		schedule:setRows(EPGView.schedule_window, titles, EPG_layout.schedule.visible_channels)

		wgt:fixOffsets(EPGView.schedule_window)
--		print('[lua] EPG.schedule.fill, Channel count = '..chCount)
--		print('[lua] EPG.schedule.fill, selected channel = '..EPG.schedule.selected_channel)
	end

	schedule:resetSlots(EPGView.schedule_window)
	local sTimeFrom,sTimeTo = schedule:getVisibleTimeRange(EPGView.schedule_window)
	getShows(sTimeFrom,sTimeTo, 0,chCount-1)
	
	schedule:moveSlotsTo(EPGView.schedule_window, currentTime)
	schedule:setCurrent( EPGView.schedule_window, EPG.schedule.selected_channel-1)
end

function getShows(timeFrom, timeTo, chFrom,chTo)
	if chFrom == nil then
		chFrom,chTo = schedule:getVisibleRowRange(EPGView.schedule_window)
	end
--	print('[lua] getShows, time from: '..timeFrom.. ', time to:'..timeTo)
--	print('[lua] getShows, channel from: '..chFrom..', channel to: '..chTo)
	for ix=chFrom,chTo do
		if EPG.schedule.channels[ix+1] then -- if it's not an empty row
			getVisibleShows(EPG.schedule.channels[ix+1].id, timeFrom, timeTo)
		end
	end
end

function fullTime(obj)
	return obj.day..' '..obj.time
end

-- GUI
function oneMinute()
	if (EPG.visible) then
		label:setText(EPGView.time, mainWindow.getTime('%d/%m/%Y - %H:%Mhs'))
		local tID = mainWindow.registerTimer(Timers.currentTime.timeout)
		Timers.currentTime.id = tID
	end
end

function unlockNeeded()
	for ix,ch in ipairs(channels.getAll()) do
		if channels.isProtected(ch.channelID)==TRUE then
			return true
		end
	end
	return false
end

function openEPG()
	log.debug( "EPG", "openEPG")
	middleware.lock(1)
	if unlockNeeded() and not PINDlg.opened then
		log.debug( "EPG", "openEPG", "unlockNeeded")
		PINDlg.init("Ingrese la clave para ver los canales bloqueados", dialogZIndex)
		PINDlg.open(showBlocked, "hideBlocked")
	else
		_openEPG(false) -- don't show data of blocked channels, just in case, because there aren't any
	end
end

function _openEPG(showBlocked)
	log.debug( "EPG", "_openEPG")
	pushCurrentWindow(EPG)
	wgt:open(EPGView.view)
	lockKeys()
	EPG.visible = true
	
	ShowBlockedChannels = showBlocked
	
	fillEPG()
	renderEPG()
end

function showBlocked()
	_openEPG(true)
end

function hideBlocked()
	pinClose()
	_openEPG(false)
end

function closeEPG()
	wgt:close(EPGView.view)
	removeWindow('EPG')

	hideEPG()
	EPG.visible = false
	unlockKeys()
	middleware.lock(0)
	checkUpdates()
end


function EPG.onOk()
--	print('[lua] ok EPG')
	if #EPG.schedule.channels > 0 then
		local id = EPG.schedule.selectedChannel().id
		if (channel.current() ~= id) then
			closeEPG()
			view.refresh()
			changeChannel(id, false)
		end
	end
	return true
end

function EPG.onExit()
--	print('[lua] exit EPG')
	closeEPG()
	return true
end

function EPG.onEPG()
--	print('[lua] onEPG')
	closeEPG()
	return true
end

function EPG.onGreen()
--	print('[lua] onEPG')
	closeEPG()
	return true
end

-- Callbacks
function showSelected(show_index)
--	print('[lua] showSelected, index='..show_index)
	EPG.schedule.selected_show = show_index
	EPG.show_description.clear()
	EPG.show_description.fill()
end

function channelSelected(channel_index)
--	print('[lua] channelSelected, index='..channel_index)
	EPG.schedule.selected_channel = channel_index+1
	EPG_layout.footer.update()
end

function needMoreShows(row_index)
	local time_from, time_to = schedule:getNextVisibleTimeRange(EPGView.schedule_window, 2)
--	print('[lua] needMoreShows, index='.. row_index ..', next_from='..time_from..', next_to='..time_to)
	getShows(time_from, time_to)
end

-- End callbacks

setIgnoredKeys(EPG, 
             { KEY_INFO, KEY_SMALL_I
             , KEY_RED, KEY_SMALL_L, KEY_SMALL_R
             , KEY_CURSOR_DOWN
             , KEY_CURSOR_LEFT
             , KEY_MUTE, KEY_SMALL_M
             , KEY_VOLUME_UP, KEY_SMALL_W
             , KEY_VOLUME_DOWN, KEY_SMALL_X
             , KEY_MENU, KEY_SMALL_C
             , KEY_AUDIO, KEY_SMALL_A
             , KEY_CHANNEL, KEY_SMALL_P
             , KEY_FAVORITES, KEY_SMALL_F
             , KEY_SUBTITLE, KEY_SMALL_S
             , KEY_ASPECT, KEY_SMALL_A
             , KEY_CH34, KEY_SMALL_H
             , KEY_VIDEO, KEY_SMALL_V
             , KEY_NUMBER_0
             , KEY_NUMBER_1
             , KEY_NUMBER_2
             , KEY_NUMBER_3
             , KEY_NUMBER_4
             , KEY_NUMBER_5
             , KEY_NUMBER_6
             , KEY_NUMBER_7
             , KEY_NUMBER_8
             , KEY_NUMBER_9
             , KEY_CHANNEL_UP, KEY_SMALL_Z
             , KEY_CHANNEL_DOWN, KEY_SMALL_Q
             })

function EPG.processKeys(key)
--	print('[lua] EPG.processKeys('.. key ..')')
	if (key == KEY_INFO) then
		-- print('[lua] all the shows')
		-- for _,c in ipairs(EPG.schedule.channels) do
		-- 	print('[lua] Channel id '..c.id)
		-- 	for k,s in ipairs(c.showsByIndex) do
		-- 		print('[lua] $ At '..k..'='..s.name.. ' ('.. fullTime(s.startDate) .. ' - '.. fullTime(s.stopDate) ..')')
		-- 	end
		-- end
		schedule:dumpShows(EPGView.schedule_window)
	end

	if wgt:processKey(EPGView.schedule_window, key) == FALSE then
		return pkey(EPG, key)
	end
	return true
end


function EPG.channelChanged(chID)
--	print('[lua] EPG.channelChanged('.. chID ..')')
	getVisibleShows(chID)
	local sTimeFrom,sTimeTo = schedule:getVisibleTimeRange(EPGView.schedule_window)
	schedule:moveSlotsTo(EPGView.schedule_window, sTimeFrom)
	EPG.show_description.fill()

	wgt:repaint(EPGView.schedule_window)
end

