Page_Channels = {
	  name="Page_Channels"
	, visible=false
	, x=PageX, y=PageY
	, width=PageW, height=PageH

	, label = "CANALES"
	, icon         = "Menu-1-Canales.png"
	, selectedicon = "Menu-1-Canales_selec.png"
	, disabledicon = "Menu-1-Canales_gris.png"
	, help = "Administración de la lista de canales.\nOK = Editar   EXIT/MENU = Salir del menú"

	, channel_list = nil
	, button_set   = nil
	, btnOneSeg    = {btn = nil, id = nil}
	, btnFav       = {btn = nil, id = nil}
	, btnBloq      = {btn = nil, id = nil}
	, btnDel       = {btn = nil, id = nil}
	, btnParental  = {btn = nil, id = nil}
	, page         = nil
	, ignoredKeys  = {}
	
	, pinRequired = {
		  dlg = nil
		, nav = {}
	}
	, confirmDelete = {
		  dlg = nil
		, nav = {}
	}
	, parental = {
		  dlg = nil
		, nav = {}
	}
	, confirmScan = {
		  dlg = nil
		, nav = {}
	}

	, scanning = false	
	, scanning_banner = {
		  window = nil
		, text   = nil
		, bar    = nil
		, NetworkCount = 0
		, CurrentNetwork = 0
		, net = ''
	}
}

local scanWindowColorTable = {  
				bgColor = Color.Black,
				borderColor = Color.White
                             }

local scanBarColorTable = {  
				bgColor = Color.DarkBlue,
				borderColor = Color.White
			  }

require "parental"

function setOneSegInfo(show, btn)
	if (show == TRUE) then
		button:label(btn, "Ocultar")
		wgt:setHelp(btn, "Oculta los canales One-Seg dentro de la lista de canales. \nOK = Ocultar    EXIT = Menú ppal.    MENU = Salir del menú")
	else
		button:label(btn, "Mostrar")
		wgt:setHelp(btn, "Muestra los canales One-Seg dentro de la lista de canales. \nOK = Mostrar    EXIT = Menú ppal.    MENU = Salir del menú")
	end
end

local buttonH = 42
local buttonW = 60

function Page_Channels.create()
	Page_Channels.page = menupage:new(0,0, PageW,PageH, 0, menuColorTable)
	menupage:setLabel(Page_Channels.page, Page_Channels.label);
	menupage:setIcons(Page_Channels.page, Page_Channels.selectedicon, Page_Channels.disabledicon, Page_Channels.icon)
	menupage:setHelp( Page_Channels.page, Page_Channels.help)

	Page_Channels.channel_list = chListCreate( 'Channel_List', PageMargin + PageBorder, PageMargin + PageBorder, PageW, PageH, 9, {61, 240, 40,40} )

	menupage:addChild( Page_Channels.page, Page_Channels.channel_list.list )

-- Buttons
	Page_Channels.button_set = buttonset:new(PageMargin + PageBorder, PageH - buttonH - PageMargin - PageBorder, 354+buttonW, buttonH, menuColorTable)
	buttonset:circular(Page_Channels.button_set, TRUE)
	menupage:addChild(Page_Channels.page, Page_Channels.button_set)

	-- favourite
	local btnFav = button:new(0, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnFav, "Fav.")
	button:icon(     btnFav, "Canales_Favorito.png","Canales_Favorito.png", 24, 20)
	button:action(   btnFav, "favPressed")
	wgt:setHelp(     btnFav, "Marca o desmarca como favorito el canal seleccionado.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnFav, "enableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnFav)
	Page_Channels.btnFav.btn = btnFav
	Page_Channels.btnFav.id = 0
	button:enable(btnFav, channels.count())

	-- block
	local btnBloq = button:new(65, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnBloq, "Bloq.")
	button:icon(     btnBloq, "Canales_Bloquear.png","Canales_Bloquear.png", 24, 20);
	button:action(   btnBloq, "bloqPressed")
	wgt:setHelp(     btnBloq, "Bloquea o desbloquea el canal seleccionado.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	buttonset:addButton(Page_Channels.button_set, btnBloq)
	Page_Channels.btnBloq.btn = btnBloq
	Page_Channels.btnBloq.id = 1
	button:enable(btnBloq, channels.count())

	-- delete
	local btnDel = button:new(130, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnDel, "Borrar")
	button:icon(     btnDel, "Canales_Borrar.png","Canales_Borrar.png", 24, 20);
	button:action(   btnDel, "delPressed")
	wgt:setHelp(     btnDel, "Borra el canal seleccionado.\nOK = Borrar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnDel, "enableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnDel)
	Page_Channels.btnDel.btn = btnDel
	Page_Channels.btnDel.id = 2
	button:enable(btnDel, channels.count())

	-- parental
	local btnParental = button:new(209, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnParental, "Padres")
	button:icon(     btnParental, "Canales_Padres.png","Canales_Padres.png", 24, 20);
	button:action(   btnParental, "parentalPressed")
	wgt:setHelp(     btnParental, "Control parental: limita el acceso a contenidos no adecuados.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnParental, "disableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnParental)
	Page_Channels.btnParental.btn = btnParental
	Page_Channels.btnParental.id = 3

	-- One-Seg
	local btnOneSeg = button:new(289, 0, buttonW, buttonH, menuColorTable)
	setOneSegInfo(channels.showOneSeg(), btnOneSeg)
	button:icon(     btnOneSeg, "Canales_One-Seg.png","Canales_One-Seg.png", 47, 20);
	button:action(   btnOneSeg, "onesegPressed")
	buttonset:addButton(Page_Channels.button_set, btnOneSeg)
	Page_Channels.btnOneSeg.btn = btnOneSeg
	Page_Channels.btnOneSeg.id = 4

	-- Scan
	local btnScan = button:new(354, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnScan, "Buscar")
	button:icon(     btnScan, "Canales_Escanear.png","Canales_Escanear.png", 24, 20);
	button:action(   btnScan, "scanPressed")
	wgt:setHelp(     btnScan, "Busca y actualiza la lista de canales.\nOK = Buscar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnScan, "disableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnScan)

-- Dialogs used in this page
	Page_Channels.pinRequired.dlg = alertdialog:new(PageX + (PageW - 385)/2,PageY + (PageH - 165)/2, 385,165, menuColorTable, dialogZIndex, PageBorder)
	alertdialog:title(   Page_Channels.pinRequired.dlg, "ADVERTENCIA")
	alertdialog:callback(Page_Channels.pinRequired.dlg, "closeDialog")
	alertdialog:text(    Page_Channels.pinRequired.dlg, "Debe establecer una clave en la pestaña CLAVE para habilitar esta opción. \n \n(OK = Volver)", 5)
	alertdialog:icon(    Page_Channels.pinRequired.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")

	Page_Channels.confirmDelete.dlg = yesnodialog:new(PageX + (PageW - 421)/2,PageY + (PageH - 195)/2, 421,195, menuColorTable, dialogZIndex, PageBorder, 75,36)
	yesnodialog:title(    Page_Channels.confirmDelete.dlg, "ADVERTENCIA")
	yesnodialog:yesAction(Page_Channels.confirmDelete.dlg, "doDeleteChannel")
	yesnodialog:noAction( Page_Channels.confirmDelete.dlg, "closeDialog")
	yesnodialog:text(     Page_Channels.confirmDelete.dlg, "¿Está seguro que desea borrar el canal seleccionado?\nPara recuperarlo deberá actualizar la lista de canales con \"Buscar canales\".", 5);
	yesnodialog:icon(     Page_Channels.confirmDelete.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")

	Page_Channels.confirmScan.dlg = yesnodialog:new(PageX + (PageW - 421)/2,PageY + (PageH - 195)/2, 421,195, menuColorTable, dialogZIndex, PageBorder, 75,36)
	yesnodialog:title(    Page_Channels.confirmScan.dlg, "ADVERTENCIA")
	yesnodialog:yesAction(Page_Channels.confirmScan.dlg, "scanConfirmed")
	yesnodialog:noAction( Page_Channels.confirmScan.dlg, "closeDialog")
	yesnodialog:text(     Page_Channels.confirmScan.dlg, "¿Está seguro que desea actualizar la lista de canales? Si lo hace, perderá las marcas de favoritos y bloqueados, y recuperará los canales borrados.", 5);
	yesnodialog:icon(     Page_Channels.confirmScan.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")

	createScanningBanner()
	createParentalDialog()

	refreshChannelsList()

	Page_Channels.activate(false)

	return Page_Channels.page
end

function createScanningBanner()
	local x      = PageMargin + PageBorder
	local y      = PageH - buttonH - PageMargin - PageBorder
	local w      = PageW - 2*(PageMargin + PageBorder)
	local h      = buttonH 
	local innerx = PageBorder
	local innery = PageBorder
	local innerw = w - 2*PageBorder
	local innerh = h - 2*PageBorder

	Page_Channels.scanning_banner.window = window:new(x,y, w,h, menuZIndex, scanWindowColorTable, PageBorder)
	Page_Channels.scanning_banner.text   = label:new(innerx + 10, innery + 5 - 8, innerw,26, menuColorTable, "Buscando canales... ", 15, Alignment.vTop_hLeft)
	window:addChild(Page_Channels.scanning_banner.window, Page_Channels.scanning_banner.text)

	local barFrame = window:new(innerx + 10, innery + 21, innerw - 20, 10, menuZIndex, scanBarColorTable)
	Page_Channels.scanning_banner.bar = bar:new(3, 3, innerw-26, 4, colorTableBar, -1, 0, 100)
	window:addChild(barFrame, Page_Channels.scanning_banner.bar)

	window:addChild(Page_Channels.scanning_banner.window, barFrame)

	menupage:addChild(Page_Channels.page, Page_Channels.scanning_banner.window)
	wgt:setVisible(Page_Channels.scanning_banner.window, FALSE)
end

function listMustIgnoreUpAndDownKeys(flag)
	wgt:ignoreKey(Page_Channels.channel_list.list, KEY_CURSOR_UP  , flag)
	wgt:ignoreKey(Page_Channels.channel_list.list, KEY_CURSOR_DOWN, flag)
end

function disableChannelList(focus)
	if focus == TRUE and chListSelectedIndex( Page_Channels.channel_list ) ~= -1 then
		listMustIgnoreUpAndDownKeys(TRUE)
		chListRefresh( Page_Channels.channel_list, FALSE )
		Page_Channels.channel_list.lastChannelSelected = chListSelectedIndex( Page_Channels.channel_list )
		chListSelectChannel( Page_Channels.channel_list, -1 )
	end
end

function enableChannelList(focus)
	if focus == TRUE and chListSelectedIndex(Page_Channels.channel_list) == -1 then
		chListRefresh( Page_Channels.channel_list, TRUE )
		Page_Channels.channel_list.lastChannelSelected = math.min(Page_Channels.channel_list.lastChannelSelected, chListRowCount(Page_Channels.channel_list)-1 )
		chListSelectChannel( Page_Channels.channel_list, Page_Channels.channel_list.lastChannelSelected )
		listMustIgnoreUpAndDownKeys(FALSE)
	end
end

function Page_Channels.pinRequired.nav.processKeys(key)
	return wgt:processKey(Page_Channels.pinRequired.dlg, key)
end

function Page_Channels.pinRequired.nav.acceptsFocus()
	return true
end

function Page_Channels.confirmDelete.nav.processKeys(key)
	return wgt:processKey(Page_Channels.confirmDelete.dlg, key)
end

function Page_Channels.confirmDelete.nav.acceptsFocus()
	return true
end

function Page_Channels.confirmScan.nav.processKeys(key)
	return wgt:processKey(Page_Channels.confirmScan.dlg, key)
end

function Page_Channels.confirmScan.nav.acceptsFocus()
	return true
end

function selectedChannelID()
	return chListCurrentChannel( Page_Channels.channel_list )
end

function toggleFlag(f)
	local id = selectedChannelID()
	f(id)
	local changedChannel = channels.get(id)
	chListUpdateChannel( Page_Channels.channel_list, changedChannel )
end

---------------------------------------------------------------------------------------------------
-- Favourite button
---------------------------------------------------------------------------------------------------

function favPressed()
	if channels.count() > 0 then
		toggleFlag(channels.toggleFavorite)
	end
end

---------------------------------------------------------------------------------------------------
-- Block button
---------------------------------------------------------------------------------------------------

function bloqPressed()
	if channels.count() > 0 then
		if PINSet() then
			PINDlg.init("Por favor, ingrese la clave", dialogZIndex)
			PINDlg.open(doBlockChannel, "pinClose")
		else
			openDialog(Page_Channels.pinRequired)
		end
	end
end

function doBlockChannel()
	toggleFlag(channels.toggleBlocked)
end

function refreshChannelsList()
	chListSetChannels( Page_Channels.channel_list, channels.getAll() )
	refreshButtons()
	if channels.count() == 0 then
		-- print("[lua] player.showSplashScreen()")
		chListSelectChannel( Page_Channels.channel_list, -1 )
		mainWindow.showBackground(1)
	end
end

---------------------------------------------------------------------------------------------------
-- Delete button
---------------------------------------------------------------------------------------------------

function delPressed()
	if channels.count() > 0 then
		openDialog(Page_Channels.confirmDelete)
 	end
end

function doDeleteChannel()
	if channels.count() > 0 then -- warn only when there are channels
		closeDialog(Page_Channels.confirmDelete)
	end
	channelDeleted(tonumber(selectedChannelID())) -- tell the chs.lua module
	channels.remove(selectedChannelID())
	local size = #channels.getAll()
	if chListSelectedIndex( Page_Channels.channel_list ) == size and size ~= 0 then
		chListSelectChannel( Page_Channels.channel_list, size-1 )
	end
	refreshChannelsList()
end

---------------------------------------------------------------------------------------------------
-- Parental button
---------------------------------------------------------------------------------------------------

function parentalPressed()
	if PINSet() then
		ParentalDialog.open()
	else
		openDialog(Page_Channels.pinRequired)
	end
end

---------------------------------------------------------------------------------------------------
-- Scan button
---------------------------------------------------------------------------------------------------

function scanPressed()
	if channels.count() > 0 then -- warn only when there are channels
		openDialog(Page_Channels.confirmScan)
	else
		scanConfirmed()
	end	
end

function scanConfirmed()
	if channels.count() > 0 then -- warn only when there are channels
		closeDialog(Page_Channels.confirmScan)
	end
	if PINSet() then
		PINDlg.init("Por favor, ingrese la clave", dialogZIndex)
		PINDlg.open(doScanChannels, "pinClose")
	else
		doScanChannels()
	end
end

function Page_Channels.scanning_banner.update(net)
	if (net ~= '') then
		Page_Channels.scanning_banner.net = net
	end
	local perc = math.floor(100 * math.min(1.0, Page_Channels.scanning_banner.CurrentNetwork/Page_Channels.scanning_banner.NetworkCount))
	local text = 'Buscando canales... '.. perc ..'% ('.. Page_Channels.scanning_banner.net ..'Mhz)'..'  -  '.. channels.count() ..' encontrados'
	
	label:setText(Page_Channels.scanning_banner.text, text)
	bar:setValue(Page_Channels.scanning_banner.bar, perc)
	wgt:setVisible(Page_Channels.button_set, FALSE)
	wgt:setVisible(Page_Channels.scanning_banner.window, TRUE)
end

function doScanChannels()
	Page_Channels.scanning = true
	wgt:setVisible(Page_Channels.scanning_banner.window, TRUE)

	chListRefresh( Page_Channels.channel_list )
	chListSetChannels( Page_Channels.channel_list, {} )
	chListSelectChannel( Page_Channels.channel_list, -1 )

	Page_Channels.scanning_banner.update('')

	tuner.startScan()
end

function Page_Channels.beginScan( networks )
	-- print( "[lua] Begin scan of " .. networks .. " networks" )
	Page_Channels.scanning_banner.NetworkCount   = networks
	Page_Channels.scanning_banner.CurrentNetwork = 0
	mainWindow.showBackground(1)
end

function Page_Channels.scanNetwork( net )
	-- print( "[lua] Begin network scan: freq= " .. net )
	Page_Channels.scanning_banner.CurrentNetwork = Page_Channels.scanning_banner.CurrentNetwork + 1
	Page_Channels.scanning_banner.update(net)
end

function Page_Channels.programFound( ch )
	-- print( "[lua] Page_Channels.programFound: " .. ch['name'] )
	chListAddChannel( Page_Channels.channel_list, ch )
	Page_Channels.scanning_banner.update('')
end

function enableButtons( enable )
	buttonset:enableButton(Page_Channels.button_set, Page_Channels.btnFav.id, enable)
	buttonset:enableButton(Page_Channels.button_set, Page_Channels.btnBloq.id, enable)
	buttonset:enableButton(Page_Channels.button_set, Page_Channels.btnDel.id, enable)
end

function refreshButtons()
	if(channels.haveChannels() > 0) then
		mainWindow.showBackground(0)
		enableButtons(TRUE)
	else
		enableButtons(FALSE)
	end
end

function Page_Channels.endScan()
	-- print( "[lua] Page_Channels.endScan" )
	Page_Channels.scanning = false
	wgt:setVisible(Page_Channels.scanning_banner.window, FALSE)
	wgt:setVisible(Page_Channels.button_set, TRUE)
	ignoreAllKeys(false)
	refreshButtons()
end

---------------------------------------------------------------------------------------------------
-- One-seg button
---------------------------------------------------------------------------------------------------

function onesegPressed()
	local ShowOneSeg = channels.toggleOneSeg()

	setOneSegInfo(ShowOneSeg, Page_Channels.btnOneSeg.btn)
	wgt:repaint(Page_Channels.btnOneSeg.btn)

	chListRefresh( Page_Channels.channel_list )
	Page_Channels.channel_list.lastChannelSelected = 0
	refreshChannelsList()
	chListSelectChannel( Page_Channels.channel_list, -1 )
end

function chooseFlagsImages( ch )
	local bn,bs = " ", " "
	local fn,fs = " ", " "
	if (ch["blocked"] == 1) then
		bs = "img:Canales_Bloquear.png"
		bn = "img:Canales_Bloquear_Blanco.png"
	end
	if (ch["favorite"] == 1) then
		fs = "img:Canales_Favorito.png"
		fn = "img:Canales_Favorito_Blanco.png"
	end
	
	return bn,bs,fn,fs
end

function Page_Channels.currentHelp()
	if (menupage:isActive(Page_Channels.page)==0) then
		return Page_Channels.help
	else
		return wgt:getHelp(Page_Channels.button_set)
	end
end

function Page_Channels.processKeys(key)
	-- print('[lua] Page_Channels.processKeys('.. key ..')')
	local ret = true

	if Page_Channels.scanning and (key ~= KEY_EXIT and key ~= KEY_ESCAPE) then
		-- print('[lua] Page_Channels.processKeys(), ignoring')
		return true
	end

	if wgt:processKey(Page_Channels.button_set, key) == 0 then
		if wgt:processKey(Page_Channels.channel_list.list, key) == 0 then
			return pkey(Page_Channels, key)
		end
	end

	MainMenu.updateHelp(Page_Channels)

	return ret
end

function Page_Channels.onExit()
	if Page_Channels.scanning then
		ignoreAllKeys(true)
		tuner.stopScan()
		--menupage:setActive(Page_Channels.page, TRUE)
		return true
	end
	return false		
end

function Page_Channels.activate(b)
	if (b) then
		enableChannelList(TRUE)
		Page_Channels.channel_list.lastChannelSelected = 0
		chListSelectChannel( Page_Channels.channel_list, -1 )
		buttonset:setActiveButton(Page_Channels.button_set, 0)
		menupage:setActive(Page_Channels.page, TRUE)
	else
		chListSelectChannel( Page_Channels.channel_list, -1 )
		buttonset:setActiveButton(Page_Channels.button_set, -1)
		menupage:setActive(Page_Channels.page, FALSE)
	end
end
