Page_Config = {
	  visible=false
	, x=PageX, y=PageY
	, width=PageW, height=PageH

	, label = "CONFIG"
	, icon         = "Menu-3-Config.png"
	, selectedicon = "Menu-3-Config_selec.png"
	, disabledicon = "Menu-3-Config_gris.png"
	, help = "Configuraciones del Set Top Box.\nOK = Editar   EXIT/MENU = Salir del menú"
	
	, page = nil
	
	, confirmChangeVideoMode = {
		  dlg = nil
		, nav = {}
		, buttons = nil
		, countdown_text = nil
	}
	
	, CompositeVideoIndex = 0
	, CompositeVideoContents = {
		  'PAL-N'
		, 'NTSC'
	}
}

WorkingTVOut     = 0
WorkingVideoMode = 0

local VIDEO_MODE_TIMEOUT = 15 --seconds

local COMBO_FONT_SIZE = 15
local ITEMS_FONT_SIZE = 15
local ITEMS_W = 240

function fillConfig( combo, list, selected )
	combobox:setItems( combo, list) 
	combobox:setSelected( combo, selected )
end

function makeCombo(x, y, w, h, title, items)
	local combo = combobox:new(x, y, w, h
		      , comboboxColorTable
                      , title, COMBO_FONT_SIZE
                      , items
                      , ITEMS_FONT_SIZE
                      , ITEMS_W)
	combobox:setMaxLines(combo, 5)
	return combo
end

function makeSlideBar(x, y, w, h, title, minValue, maxValue, step)
	return slidebar:new(x, y, w, h
                      , title, COMBO_FONT_SIZE
                      , minValue
                      , maxValue
		      , comboboxColorTable
                      , step)
end

local COMBO_X = 0
local COMBO_Y = 0
local COMBO_W = PageW - 2*(PageBorder + PageMargin)
local COMBO_H =  26

local tvOutCombo   = makeCombo(   COMBO_X, COMBO_Y                  , COMBO_W, COMBO_H, "Salida de video",      {"dummy"})
local videoCombo   = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)  , COMBO_W, COMBO_H, "Resolución",           {"dummy"})
local aspectCombo  = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)*2, COMBO_W, COMBO_H, "Relación de aspecto",  {"dummy"})
local audioCombo   = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)*3, COMBO_W, COMBO_H, "Audio",                {"dummy"})
local channelCombo = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)*4, COMBO_W, COMBO_H, "Canal",                {"dummy"})
local opacityBar   = makeSlideBar(COMBO_X, COMBO_Y + (COMBO_H + 5)*5, COMBO_W, COMBO_H, "Opacidad del menú",   1, 10, 1)
local gingaCombo   = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)*6, COMBO_W, COMBO_H, "Ginga",                {"Deshabilitado", "Habilitado"})
local updatesCombo = makeCombo(   COMBO_X, COMBO_Y + (COMBO_H + 5)*7, COMBO_W, COMBO_H, "Actualizaciones",      {"Deshabilitado", "Habilitado"})
local appsBtn   = button:new( COMBO_X, COMBO_Y + (COMBO_H + 5)*8, COMBO_W, COMBO_H, menuColorTable)
local restoreBtn   = button:new(83, 300 - (PageBorder + PageMargin), 290, 26, menuColorTable)
button:label(    appsBtn, "Configurar Aplicaciones")
button:fontSize( appsBtn, 15)
button:enable( appsBtn, zmb_apps.enabled())
button:label(    restoreBtn, "Restablecer a valores de fábrica")
button:fontSize( restoreBtn, 15)

--	Actions
combobox:action(tvOutCombo,   "tvOutChanged"    )
combobox:action(videoCombo,   "videoModeChanged")
combobox:action(aspectCombo,  "aspectChanged"   )
combobox:action(audioCombo,   "audioChanged"    )
combobox:action(channelCombo, "channelChanged"  )
slidebar:action(opacityBar,   "opacityChanged"  )
combobox:action(gingaCombo,   "gingaChanged"    )
combobox:action(updatesCombo, "updatesChanged"  )
button:action  (restoreBtn,   "restorePressed"  )
button:action  (appsBtn,      "appsPressed"  )

--	Helps
wgt:setHelp(tvOutCombo,   "Modifica la salida de video.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(videoCombo,   "Modifica la resolución de la salida de video.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(aspectCombo,  "Modifica la relación de aspecto.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(audioCombo,   "Modifica la salida de audio.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(channelCombo, "Permite seleccionar si la salida analógica es por el canal 3 o 4.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(opacityBar,   "Modifica la opacidad del menú.\n< > = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(gingaCombo,   "Permite habilitar o deshabilitar Ginga.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(updatesCombo, "Permite seleccionar si se desea recibir actualizaciones.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(appsBtn,   "Permite configurar las aplicaciones residentes.\nOK = Ingresar    EXIT = Menú ppal.    MENU = Salir del menú")
wgt:setHelp(restoreBtn,   "Restablece los valores de fábrica.\nOK = Restablecer    EXIT = Menú ppal.    MENU = Salir del menú")

function Page_Config.create()
	Page_Config.page = menupage:new(0,0, PageW,PageH, 140, menuColorTable)
	menupage:setLabel(Page_Config.page, "CONFIG");
	menupage:setIcons(Page_Config.page, "Menu-3-Config_selec.png", "Menu-3-Config_gris.png", "Menu-3-Config.png")
	menupage:setHelp( Page_Config.page, Page_Config.help)

	local verticalSet = verticalset:new(PageBorder + PageMargin,PageBorder + PageMargin, COMBO_W, 335 - (PageBorder + PageMargin),menuColorTable)
	verticalset:addWidget(verticalSet, tvOutCombo)
	verticalset:addWidget(verticalSet, videoCombo)
	verticalset:addWidget(verticalSet, aspectCombo)
	verticalset:addWidget(verticalSet, audioCombo)
	verticalset:addWidget(verticalSet, channelCombo)
	verticalset:addWidget(verticalSet, opacityBar)
	verticalset:addWidget(verticalSet, gingaCombo)
	verticalset:addWidget(verticalSet, updatesCombo)
	verticalset:addWidget(verticalSet, appsBtn)
	verticalset:addWidget(verticalSet, restoreBtn)
	verticalset:circular(verticalSet, TRUE)

	fillConfigCombos()

	Page_Config.verticalSet = verticalSet
	menupage:addChild(Page_Config.page, verticalSet)
	
	createConfirmChangeVideoMode()
	
	local connectors,_ = display.getConnectors()
	for ix,c in pairs(connectors) do
		if c=='Video Compuesto' then
			Page_Config.CompositeVideoIndex = ix-1
		end
	end
--	print('[lua] CompositeVideoIndex='..Page_Config.CompositeVideoIndex)

	WorkingTVOut     = combobox:getSelected(tvOutCombo)
	WorkingVideoMode = combobox:getSelected(videoCombo)
	
	return Page_Config.page
end

RestoreConfirmDlg = {
	  dlg = yesnodialog:new(PageX + (PageW-400)/2, PageY + (PageH-195)/2, 400, 195, menuColorTable, dialogZIndex, 4, 75, 36)
	, nav = {}
}

yesnodialog:title(RestoreConfirmDlg.dlg, "ADVERTENCIA")
yesnodialog:icon( RestoreConfirmDlg.dlg, "Confirmacion.png", 70, 61, "Confirmacion_Gris.png")
yesnodialog:text( RestoreConfirmDlg.dlg, "¿Está seguro que desea restablecer los valores del fabricante?\nSi lo hace, se eliminarán todos los ajustes que haya hecho previamente.", 5)
yesnodialog:yesAction(RestoreConfirmDlg.dlg, "confirmResetConfig")
yesnodialog:noAction( RestoreConfirmDlg.dlg, "dontResetConfig")
wgt:setVisible(RestoreConfirmDlg.dlg, FALSE)

function RestoreConfirmDlg.nav.processKeys(key)
--	print("[lua] RestoreConfirmDlg.Nav(" .. key .. ")")
	return wgt:processKey(RestoreConfirmDlg.dlg, key)
end

function RestoreConfirmDlg.nav.acceptsFocus()
	return true
end

function createConfirmChangeVideoMode()
	local width, height = 423,200
	Page_Config.confirmChangeVideoMode.dlg = basicdialog:new(PageX + (PageW-width)/2, PageY + (PageH-height)/2, width,height, menuColorTable, dialogZIndex, PageBorder)
	basicdialog:title(Page_Config.confirmChangeVideoMode.dlg, "ADVERTENCIA")
--	basicdialog:icon( Page_Config.confirmChangeVideoMode.dlg, "Confirmacion.png", 70,61) -- no se ve donde corresponde asi
	local icon = image:new(PageBorder + PageMargin, PageBorder + PageMargin + 26, 70,61, menuZIndex, menuColorTable, "Confirmacion.png")
	basicdialog:addChild(Page_Config.confirmChangeVideoMode.dlg, icon)

	local text1 = textarea:new(98,40, 300,50, menuColorTable
							, "Ha cambiado la configuración de video.\n¿Desea conservar los cambios?"
							, 14 -- Font Size
							, 2  -- Lines
							, 4  -- Margin
							, Alignment.vTop_hLeft)
	Page_Config.confirmChangeVideoMode.countdown_text = label:new(98,100 + 70 - 8, 300,25, menuColorTable, string.format("Se revertirá en %d segundos.", VIDEO_MODE_TIMEOUT), 15, Alignment.vTop_hLeft, 4)

	basicdialog:addChild(Page_Config.confirmChangeVideoMode.dlg, text1)
	basicdialog:addChild(Page_Config.confirmChangeVideoMode.dlg, Page_Config.confirmChangeVideoMode.countdown_text)

	local buttonW, buttonH = 90,36
	local buttonX = width/2
	local buttonY = 0
	Page_Config.confirmChangeVideoMode.buttons = buttonset:new(98 + 4, height - buttonH - PageMargin - PageBorder - 20 - 8, 2*buttonW+10, buttonH, menuColorTable)
	basicdialog:addChild(Page_Config.confirmChangeVideoMode.dlg, Page_Config.confirmChangeVideoMode.buttons)

	local btnYes = button:new(0, buttonY, buttonW, buttonH, menuColorTable)
	button:label(    btnYes, "SI")
	button:fontSize( btnYes, 20)
	button:action(   btnYes, "keepVideoModePressed")
	buttonset:addButton(Page_Config.confirmChangeVideoMode.buttons, btnYes)

	local btnNo = button:new(buttonW + 10, buttonY, buttonW, buttonH, menuColorTable)
	button:label(    btnNo, "NO")
	button:fontSize( btnNo, 20)
	button:action(   btnNo, "discardVideoModePressed")
	buttonset:addButton(Page_Config.confirmChangeVideoMode.buttons, btnNo)

	wgt:fixOffsets(Page_Config.confirmChangeVideoMode.dlg)
end

function Page_Config.confirmChangeVideoMode.nav.processKeys(key)
--	print("[lua] Page_Config.confirmChangeVideoMode.processKeys(" .. key .. ")")
	if wgt:processKey(Page_Config.confirmChangeVideoMode.buttons, key) == TRUE then
		return true
	end
	return pkey(Page_Config.confirmChangeVideoMode, key)
end

function Page_Config.confirmChangeVideoMode.nav.acceptsFocus()
	return true
end

function Page_Config.confirmChangeVideoMode.onExit()
--	print("[lua] Page_Config.confirmChangeVideoMode.onExit()")
	discardVideoModePressed()
	return true
end

---- Confirm Video Mode
function cancelVideoModeTimeOut()
	mainWindow.cancelTimer(Timers['videoModeTimeOut']['id']);
end

function videoModeTick()
	VideoModeRemainTime = VideoModeRemainTime - 1
	label:setText(Page_Config.confirmChangeVideoMode.countdown_text, string.format("Se revertirá en %d segundos.", VideoModeRemainTime))
	if VideoModeRemainTime > 0 then
		Timers['videoModeTimeOut']['id'] = mainWindow.registerTimer(Timers['videoModeTimeOut']['timeout'])
	else
		closeDialog(Page_Config.confirmChangeVideoMode)
		revertChangeVideoMode()
	end
end

function confirmSetVideoMode()
	buttonset:setActiveButton(Page_Config.confirmChangeVideoMode.buttons, 1)
	VideoModeRemainTime = VIDEO_MODE_TIMEOUT
	label:setText(Page_Config.confirmChangeVideoMode.countdown_text, string.format("Se revertirá en %d segundos.", VideoModeRemainTime))
	openDialog(Page_Config.confirmChangeVideoMode)
	Timers['videoModeTimeOut']['id'] = mainWindow.registerTimer(Timers['videoModeTimeOut']['timeout'])
end

function changeVideoMode( tv, video )
	-- print('[lua] videoModeChanged(): tv=' .. tv .. " video=" .. video )
	display.setVideoMode(tv, video)
end

-- Combos callbacks
local TVOutChanged = false
function tvOutChanged(changed)
	if changed == TRUE then
		local nextTvOut = combobox:getSelected(tvOutCombo)
		-- print( "[lua] tvOutChanged: selected=" .. nextTvOut )
		fillVideoCombo(display.getVideoModes(nextTvOut))
		combobox:setTempItem(videoCombo, "Debe configurar esta opción")
		TVOutChanged = true
	end
end

function videoModeChanged(changed)
	if TVOutChanged or changed==TRUE then
		-- print( "[lua] videoModeChanged(".. changed .. ")")
		local tv    = combobox:getSelected(tvOutCombo)
		local video = combobox:getSelected(videoCombo)
		changeVideoMode( tv, video )
		confirmSetVideoMode()
	end
	TVOutChanged = false
end

function revertChangeVideoMode()
	-- print("[lua] revertChangeVideoMode(), WorkingTVOut="..WorkingTVOut..", WorkingVideoMode="..WorkingVideoMode)
	combobox:setSelected(tvOutCombo, WorkingTVOut)
	fillVideoCombo(display.getVideoModes(WorkingTVOut))
	combobox:setSelected(videoCombo, WorkingVideoMode)
	changeVideoMode( WorkingTVOut, WorkingVideoMode )
end

function keepVideoModePressed()
--	print("[lua] keepVideoModePressed()")
	WorkingTVOut     = combobox:getSelected(tvOutCombo)
	WorkingVideoMode = combobox:getSelected(videoCombo)
	cancelVideoModeTimeOut()
	closeDialog(Page_Config.confirmChangeVideoMode)
end

function discardVideoModePressed()
--	print("[lua] discardVideoModePressed()")
	cancelVideoModeTimeOut()
	closeDialog(Page_Config.confirmChangeVideoMode)
	revertChangeVideoMode()
end

function aspectChanged()
	local selected = combobox:getSelected(aspectCombo)
	display.setAspectMode( selected )
end

function channelChanged()
	local selected = combobox:getSelected(channelCombo)
	display.setModulator( selected )
end

function gingaChanged()
	local enable = combobox:getSelected(gingaCombo)
	middleware.enable( enable )
end

function updatesChanged()
	local enable = combobox:getSelected(updatesCombo)
	update.enable(enable)
end

function audioChanged()
	local selected = combobox:getSelected(audioCombo)
	player.setAudioChannel(selected)
end

function opacityChanged()
	local transparency = slidebar:getValue(opacityBar)
	display.setTransparency(transparency)
end

-- Reset To Defaults
function restorePressed()
	openDialog(RestoreConfirmDlg)
end

function confirmResetConfig()
	askForPin(doResetConfig, "cancelReset")
end

function appsPressed()
	askForPin(zmb_apps.openAppsList, "pinClose")
end

function askForPin(func, cancelCbk)
	if PINSet() then
		PINDlg.init("Por favor, ingrese la clave", dialogZIndex)
		PINDlg.open(func, cancelCbk)
	else
		func()
	end
end

function cancelReset()
	pinClose()
	dontResetConfig()
end

function doResetConfig()
	closeDialog() -- RestoreConfirmDlg

	mainWindow.resetConfig()
	zmb_apps.restore()
	refreshChannelsList()
	fillConfigCombos()
	WorkingTVOut = combobox:getSelected(tvOutCombo)
end

function dontResetConfig()
	closeDialog() -- RestoreConfirmDlg
end

function fillVideoCombo(list, selected)
	local nextTvOut = combobox:getSelected(tvOutCombo)
	if nextTvOut == Page_Config.CompositeVideoIndex then
		list = Page_Config.CompositeVideoContents
	end
	fillConfig( videoCombo, list, selected )
end

function fillConfigCombos()
--	print( "[lua] fillConfigCombos()" )
	fillConfig( tvOutCombo, display.getConnectors() )
	fillVideoCombo(display.getCurVideoModes())
	fillConfig( aspectCombo, display.getAspectModes() )
	fillConfig( audioCombo, player.getAudioChannels() )
	fillConfig( channelCombo, display.getModulators() )
	slidebar:setValue( opacityBar, display.getTransparency() )
	combobox:setSelected( gingaCombo, middleware.isEnabled() )
	combobox:setSelected( updatesCombo, update.isEnabled() )   
end


-- Page functions
function Page_Config.processKeys(key)
	-- print('[lua] Page_Config.processKeys('.. key ..')')
	local ret = true
	if wgt:processKey(Page_Config.verticalSet, key) == 0 then
		ret = false
	end

	MainMenu.updateHelp(Page_Config)

	return ret
end

function Page_Config.select(b)
	if b then
		combobox:setSelected( tvOutCombo, display.getConnector() )
		fillVideoCombo(display.getCurVideoModes())
		combobox:setSelected( aspectCombo, display.getAspectMode() )
		combobox:setSelected( audioCombo, player.getAudioChannel() )
		combobox:setSelected( channelCombo, display.getModulator() )
		--slidebar:setValue( opacityBar, display.getTransparency() )
		combobox:setSelected( gingaCombo, middleware.isEnabled() )
		combobox:setSelected( updatesCombo, update.isEnabled() )   
	end
end

function closeCombos()
	local allCombos = {tvOutCombo, videoCombo, aspectCombo, audioCombo, channelCombo, gingaCombo, updatesCombo}
	for i=1, #allCombos do
		combobox:close(allCombos[i])
	end
end

function Page_Config.activate(b)
	if (b) then
		verticalset:setActiveItem(Page_Config.verticalSet, 0)
		menupage:setActive(Page_Config.page, TRUE)
	else
		verticalset:setActiveItem(Page_Config.verticalSet, -1)
		menupage:setActive(Page_Config.page, FALSE)

		combobox:hideTempItem(videoCombo)		
		combobox:setSelected( tvOutCombo, display.getConnector() )
		fillVideoCombo(display.getCurVideoModes())
		
		closeCombos()
	end
end

function Page_Config.currentHelp()
	if (menupage:isActive(Page_Config.page)==0) then
		return Page_Config.help
	else
		return wgt:getHelp(Page_Config.verticalSet)
	end
end



