Page_PIN = {
	  name="Page_PIN"
	, visible=false
	, x=PageX, y=PageY
	, width=PageW, height=PageH

	, label = "CLAVE"
	, icon         = "Menu-4-Clave.png"
	, selectedicon = "Menu-4-Clave_selec.png"
	, disabledicon = "Menu-4-Clave_gris.png"
	, help = "Modifica la clave del sistema.\nOK = Modificar clave   EXIT/MENU = Salir del menú"
	
	, page = nil
	, setKeyWindow  = nil
	, setKeyButtons = nil
	, inputWindow   = nil
	, buttons       = nil
	
	, pin1 = nil
	, pin8 = nil
	, labelsAreActive = false
	
	, pinStored = {
		  dlg = nil
		, nav = {}
	}
	, pinUnmatched = {
		  dlg = nil
		, nav = {}
	}
	, confirmDelete = {
		  dlg = nil
		, nav = {}
	}

}

local PINcolorTable = {  
				bgColor = Color.None,
				bgLabelColor = Color.DarkBlue,
				textColor = Color.White
		      }
		
local modifyPINcolorTable = {  
				bgColor = Color.None,
				bgLabelColor = Color.Blue,
				selectedColor = Color.White,
				textColor = Color.White,
				selectedTextColor = Color.Black
			    }

function Page_PIN.create()
	Page_PIN.page = menupage:new(0,0, PageW,PageH, 210, menuColorTable)
	menupage:setLabel(Page_PIN.page, Page_PIN.label)
	menupage:setIcons(Page_PIN.page, Page_PIN.selectedicon, Page_PIN.disabledicon, Page_PIN.icon)
	menupage:setHelp( Page_PIN.page, Page_PIN.help)

	local x = PageBorder + PageMargin
	local y = PageBorder + PageMargin
	createPINUnset(x, y + 65)
	createPINSet(x, y)
	
	local pindlg_dw = 385
	local pindlg_dh = 165
	local pindlg_dx = PageX + (PageW - pindlg_dw)/2
	local pindlg_dy = PageY + (PageH - pindlg_dh)/2

	Page_PIN.pinStored.dlg = alertdialog:new(pindlg_dx,pindlg_dy, pindlg_dw,pindlg_dh, menuColorTable, dialogZIndex, PageBorder)
	alertdialog:title(   Page_PIN.pinStored.dlg, "CLAVE")
	alertdialog:callback(Page_PIN.pinStored.dlg, "pinStored")
	alertdialog:text(    Page_PIN.pinStored.dlg, "La nueva clave ha sido guardada.\n \n (OK = Aceptar)", 3)
	alertdialog:icon(    Page_PIN.pinStored.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")

	Page_PIN.pinUnmatched.dlg = alertdialog:new(pindlg_dx,pindlg_dy, pindlg_dw,pindlg_dh, menuColorTable, dialogZIndex, PageBorder)
	alertdialog:title(   Page_PIN.pinUnmatched.dlg, "ADVERTENCIA")
	alertdialog:callback(Page_PIN.pinUnmatched.dlg, "correctPIN")
	alertdialog:text(    Page_PIN.pinUnmatched.dlg, "Los valores no coinciden. Por favor, ingrese nuevamente la clave y su confirmación.\n \n (OK = Volver)", 5)
	alertdialog:icon(    Page_PIN.pinUnmatched.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")


	local delete_dw = 426
	local delete_dh = 200
	local delete_dx = PageX + (PageW - delete_dw)/2
	local delete_dy = PageY + (PageH - delete_dh)/2
	local delete_bw =  75
	local delete_bh =  36

	Page_PIN.confirmDelete.dlg = yesnodialog:new(delete_dx,delete_dy, delete_dw,delete_dh, menuColorTable, dialogZIndex, PageBorder, delete_bw,delete_bh)
	yesnodialog:title(    Page_PIN.confirmDelete.dlg, "ADVERTENCIA")
	yesnodialog:yesAction(Page_PIN.confirmDelete.dlg, "deletePIN")
	yesnodialog:noAction( Page_PIN.confirmDelete.dlg, "closeDialog")
	yesnodialog:text(     Page_PIN.confirmDelete.dlg, "¿Está seguro que desea borrar la clave del sistema? Si lo hace, perderá las marcas de canales bloqueados y la configuración de control parental.", 4)
	yesnodialog:icon(     Page_PIN.confirmDelete.dlg, "Confirmacion.png", 70,61, "Confirmacion_Gris.png")


	wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
	wgt:setVisible(Page_PIN.inputWindow, FALSE)
	wgt:setVisible(Page_PIN.buttons, FALSE)
	
	return Page_PIN.page
end

function createPINUnset(x,y)
	local setkeyw = PageW - 2*(PageBorder + PageMargin)
	local setkeyh = 130
	Page_PIN.setKeyWindow = window:new(x, y, setkeyw, setkeyh, menuZIndex, menuColorTable)
	Page_PIN.setKeyButtons = buttonset:new(0, 0, 0, 0, menuColorTable)
	local text = textarea:new(setkeyw * 0.1
							, PageMargin
							, setkeyw * 0.85
							, 50
							, menuColorTable
							, "El sistema no tiene clave.\nPresione OK para establecer una clave nueva."
							, 16
							, 2
							, 0
							, Alignment.vTop_hCenter)

	local buttonx = (setkeyw-160)/2
	local buttony = setkeyh- (30 + PageMargin)
	local buttonw = 160
	local buttonh = 30
	local btnEstablecer = button:new(buttonx, buttony, buttonw, buttonh, menuColorTable)
	button:label(    btnEstablecer, "Establecer clave")
	button:action(   btnEstablecer, "setPIN")
	wgt:setHelp(     btnEstablecer, "Permite establecer una clave de seguridad para el sistema\nOK = Establecer clave   EXIT = Salir   MENU = Salir del menú")
	buttonset:addButton(Page_PIN.setKeyButtons, btnEstablecer)
	buttonset:setActiveButton(Page_PIN.setKeyButtons, 0)
		
	window:addChild(Page_PIN.setKeyWindow, text)
	window:addChild(Page_PIN.setKeyWindow, Page_PIN.setKeyButtons)
	
	menupage:addChild(Page_PIN.page, Page_PIN.setKeyWindow)
end

function createPINSet(x,y)
	local inputWindowW = PageW - 2*(PageBorder + PageMargin)
	local inputWindowH = PageH - 2*(PageBorder + PageMargin)
	
	Page_PIN.inputWindow  = window:new(x, y, inputWindowW, inputWindowH, menuZIndex, menuColorTable)

	local step1      = label:new(  0,  8, 100, 20, menuColorTable, "PASO 1.", 15, Alignment.vTop_hLeft, 0)
	Page_PIN.label1  = label:new(  0, 30, 410, 26, modifyPINcolorTable, "Escriba una clave de 4 números", 15, Alignment.vTop_hLeft, 3)
	Page_PIN.pin1    = label:new(260, 33, 146, 20, PINcolorTable, "", 16, Alignment.vBottom_hLeft, 5)
	label:setMask(Page_PIN.pin1, "    *")
	label:setEmptyMask(Page_PIN.pin1, "    _")
	label:setTextLength(Page_PIN.pin1, 4)

	local step2      = label:new(  0, 68, 100, 20, menuColorTable, "PASO 2.", 15, Alignment.vTop_hLeft, 0)
	Page_PIN.label2  = label:new(  0, 90, 410, 26, modifyPINcolorTable, "Escriba nuevamente la clave", 15, Alignment.vBottom_hLeft, 3)
	Page_PIN.pin8    = label:new(260, 93, 146, 20, PINcolorTable, "", 16, Alignment.vBottom_hLeft, 5)
	label:setMask(Page_PIN.pin8, "    *")
	label:setEmptyMask(Page_PIN.pin8, "    _")
	label:setTextLength(Page_PIN.pin8, 4)

	window:addChild(Page_PIN.inputWindow, step1)
	window:addChild(Page_PIN.inputWindow, Page_PIN.label1)
	window:addChild(Page_PIN.inputWindow, Page_PIN.pin1)
	window:addChild(Page_PIN.inputWindow, step2)
	window:addChild(Page_PIN.inputWindow, Page_PIN.label2)
	window:addChild(Page_PIN.inputWindow, Page_PIN.pin8)
	
	menupage:addChild(Page_PIN.page, Page_PIN.inputWindow)

	Page_PIN.buttons      = buttonset:new(x, PageH - 2*(PageBorder + PageMargin) - 30, inputWindowW/2+5+120, 30, menuColorTable)

	local buttonModificar = button:new(inputWindowW/2 - 125, 0, 120,30, menuColorTable);
	button:label( buttonModificar, "Modificar Clave")
	button:action(buttonModificar, "modifyPIN")
	wgt:setHelp(  buttonModificar, "Modifica la clave de seguridad para el sistema\nOK = Modificar clave    EXIT = Salir    MENU = Salir del menú")

	local buttonEliminar = button:new(inputWindowW/2 + 5, 0, 120,30, menuColorTable)
	button:label( buttonEliminar, "Eliminar Clave")
	button:action(buttonEliminar, "confirmDeletePIN")
	wgt:setHelp(  buttonEliminar, "Elimina la clave de seguridad para el sistema\nOK = Eliminar clave    EXIT = Salir    MENU = Salir del menú")

	buttonset:addButton(Page_PIN.buttons, buttonModificar)
	buttonset:addButton(Page_PIN.buttons, buttonEliminar)

	menupage:addChild(Page_PIN.page, Page_PIN.buttons)
end

function Page_PIN.pinStored.nav.processKeys(key)
	return wgt:processKey(Page_PIN.pinStored.dlg, key)
end

function Page_PIN.pinStored.nav.acceptsFocus()
	return true
end

function Page_PIN.pinUnmatched.nav.processKeys(key)
	return wgt:processKey(Page_PIN.pinUnmatched.dlg, key)
end

function Page_PIN.pinUnmatched.nav.acceptsFocus()
	return true
end

function Page_PIN.confirmDelete.nav.processKeys(key)
	return wgt:processKey(Page_PIN.confirmDelete.dlg, key)
end

function Page_PIN.confirmDelete.nav.acceptsFocus()
	return true
end

function Page_PIN.select(b)
--	print('[lua] Page_PIN.select')
	if (not b) then
		wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
		wgt:setVisible(Page_PIN.inputWindow, FALSE)
		wgt:setVisible(Page_PIN.buttons, FALSE)
	end
end

function Page_PIN.activate(b)
	if (b) then
		wgt:setVisible(Page_PIN.page, TRUE)
		if not PINSet() then
			if not Page_PIN.labelsAreActive then
				-- print('[lua] Page_PIN.activate, no PIN set')
				buttonset:setActiveButton(Page_PIN.buttons, 0)
				wgt:setVisible(Page_PIN.setKeyWindow, TRUE)
				wgt:setVisible(Page_PIN.inputWindow,  FALSE)
				wgt:setVisible(Page_PIN.buttons,      FALSE)
				menupage:setActive(Page_PIN.page, TRUE)
			end
		else
			-- print('[lua] Page_PIN.activate')
			PINDlg.init("Por favor, ingrese la clave", dialogZIndex)
			PINDlg.open(unblockPINPage, "pinClose")
		end
	else
		buttonset:setActiveButton(Page_PIN.buttons, -1)
		menupage:setActive(Page_PIN.page, FALSE)
	end
end

function unblockPINPage()
	-- print('[lua] unblockPINPage')
	menupage:setActive(Page_PIN.page, TRUE)

	if not Page_PIN.labelsAreActive then
		buttonset:setActiveButton(Page_PIN.buttons, 0)
		label:setText(Page_PIN.pin1, "    ")
		label:setText(Page_PIN.pin8, "    ")
		wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
		wgt:setVisible(Page_PIN.inputWindow,  TRUE)
		wgt:setVisible(Page_PIN.buttons,      TRUE)
	end
end

function Page_PIN.currentHelp()
	if wgt:isVisible(Page_PIN.buttons) == TRUE then
		return wgt:getHelp(Page_PIN.buttons)
	elseif wgt:isVisible(Page_PIN.setKeyButtons) == TRUE or Page_PIN.labelsAreActive then
		return wgt:getHelp(Page_PIN.setKeyButtons)
	else
		return Page_PIN.help
	end
end

function Page_PIN.processKeys(key)
	-- print('[lua] Page_PIN.processKeys('.. key ..')')
	local ret = false

	if (wgt:isVisible(Page_PIN.setKeyWindow) == TRUE) then	
		-- print('[lua] Page_PIN.processKeys, trying with setKeyWindow')
		ret = wgt:processKey(Page_PIN.setKeyButtons, key) ~= 0
	end
	if (not ret and wgt:isVisible(Page_PIN.buttons) == TRUE) then	
		-- print('[lua] Page_PIN.processKeys, trying with buttons')
		ret = wgt:processKey(Page_PIN.buttons, key) ~= 0
	end
	if (not ret) then
		-- print('[lua] Page_PIN.processKeys, trying with self')
		ret = pkey(Page_PIN, key)
	end

	MainMenu.updateHelp(Page_PIN)

	return ret
end


function setPIN()
	-- print('[lua] setPIN()')
	label:setText(Page_PIN.pin1, "")
	label:setText(Page_PIN.pin8, "")

	activateLabels()
	wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
	wgt:setVisible(Page_PIN.inputWindow,  TRUE)
	wgt:setVisible(Page_PIN.buttons,      FALSE)
end

function modifyPIN()
	-- print('[lua] modifyPIN()')
	label:setText(Page_PIN.pin1, "")
	label:setText(Page_PIN.pin8, "")
	activateLabels()

	wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
	wgt:setVisible(Page_PIN.inputWindow,  TRUE)
	wgt:setVisible(Page_PIN.buttons,      FALSE)
end

function correctPIN()
	-- print('[lua] correctPIN()')
	label:setText(Page_PIN.pin1, "")
	label:setText(Page_PIN.pin8, "")

	closeDialog(Page_PIN.pinUnmatched)
	activateLabels()
	wgt:setVisible(Page_PIN.setKeyWindow, FALSE)
	wgt:setVisible(Page_PIN.inputWindow,  TRUE)
	wgt:setVisible(Page_PIN.buttons,      FALSE)
end

function pinStored()
	closeDialog(Page_PIN.pinStored)

	deactivateLabels()
	wgt:setVisible(Page_PIN.setKeyWindow, FALSE)--, TRUE)
	wgt:setVisible(Page_PIN.inputWindow,  TRUE)--,  TRUE)
	wgt:setVisible(Page_PIN.buttons,      TRUE)--,  TRUE)
	buttonset:setActiveButton(Page_PIN.buttons, 0)
	MainMenu.updateHelp(Page_PIN)
end

function deletePIN()
	-- print('[lua] modifyPIN()')
	closeDialog(Page_PIN.confirmDelete)

	label:setText(Page_PIN.pin1, "")
	label:setText(Page_PIN.pin8, "")
	control.resetPIN()

	wgt:setVisible(Page_PIN.setKeyWindow, TRUE)
	wgt:setVisible(Page_PIN.inputWindow,  FALSE)
	wgt:setVisible(Page_PIN.buttons,      FALSE)
	MainMenu.updateHelp(Page_PIN)
	refreshChannelsList()
end

function confirmDeletePIN()
	-- print('[lua] confirmDeletePIN()')
	openDialog(Page_PIN.confirmDelete)
end

function Page_PIN.show(active)
--	Page_PIN.render(active)
end

function Page_PIN.render(active)
--	print('[lua] Page_PIN.render'))
end


function activateLabels()
	local activeLabel, inactiveLabel
	local update = false
	if (#label:getRawText(Page_PIN.pin1) == 0) then
		Page_PIN.labelsAreActive = true
		activeLabel   = Page_PIN.label1
		inactiveLabel = Page_PIN.label2
		update = true
	end
	if (#label:getRawText(Page_PIN.pin1) == PINLength-1) then
		activeLabel   = Page_PIN.label2
		inactiveLabel = Page_PIN.label1
		update = true
	end
	if update then
		label:setBgColor(inactiveLabel, modifyPINcolorTable.bgLabelColor)
		label:setColor  (inactiveLabel, modifyPINcolorTable.textColor)
		label:setBgColor(activeLabel,   modifyPINcolorTable.selectedColor)
		label:setColor  (activeLabel,   modifyPINcolorTable.selectedTextColor)
		wgt:repaint(Page_PIN.pin1)
		wgt:repaint(Page_PIN.pin8)
	end
end

function deactivateLabels()
	Page_PIN.labelsAreActive = false
	label:setBgColor(Page_PIN.label1, modifyPINcolorTable.bgLabelColor)
	label:setColor  (Page_PIN.label1, modifyPINcolorTable.textColor)
	label:setBgColor(Page_PIN.label2, modifyPINcolorTable.bgLabelColor)
	label:setColor  (Page_PIN.label2, modifyPINcolorTable.textColor)
end

function Page_PIN.onDigit(d)
	if (wgt:isVisible(Page_PIN.inputWindow) == TRUE) and (wgt:isVisible(Page_PIN.buttons) == FALSE) then
	 	-- print('[lua] Page_PIN.onDigit('..d..')')
		activateLabels()
		if (#label:getRawText(Page_PIN.pin1) < PINLength) then
			label:setText(Page_PIN.pin1, label:getRawText(Page_PIN.pin1) .. d)
		else
			label:setText(Page_PIN.pin8, label:getRawText(Page_PIN.pin8) .. d)
		end

		local pin1raw = label:getRawText(Page_PIN.pin1)
		local pin8raw = label:getRawText(Page_PIN.pin8)
	 	-- print('[lua] Page_PIN.onDigit, pins='..pin1raw.. ', '..pin8raw)
		if (#pin1raw == #pin8raw) then
			if (pin1raw == pin8raw) then
				-- print('[lua] pin set, '..pin1raw)
				control.setPIN( pin1raw )
				openDialog(Page_PIN.pinStored)
			else
				-- print('[lua] unmatched pins')
				openDialog(Page_PIN.pinUnmatched)
			end		
		end
	end
	return true
end

function Page_PIN.onUp()
	return true
end

function Page_PIN.onDown()
	return true
end

function Page_PIN.onExit()
	deactivateLabels()
	wgt:setVisible(Page_PIN.page, FALSE)
	return false
end
