local TAB_APP = 0
local TAB_IMG = 1
local TAB_MUSIC = 2
local TAB_WWW = 3

local lastTab = TAB_APP

require "applicationmanager"

Page_USB = {
	  visible=false
	, x=PageX, y=PageY
	, width=PageW, height=PageH

	, show_count=9

	, label = "MMEDIA"
	, icon         = "Menu-2-MMedia.png"
	, selectedicon = "Menu-2-MMedia_selec.png"
	, disabledicon = "Menu-2-MMedia_gris.png"
	, help = "Permite acceder a contenidos multimedia.\nOK = Ver contenido   EXIT/MENU = Salir del menú"
	
	, page = nil
	, list = nil
	, button_set = nil
	, apps = {
		  visible_columns={"name"}
		, headers={'Aplicaciones'}
		, index_key="id"
		, columns_sizes={390}
		, list = nil
		, disabled = nil
	}
	, images = {
		  visible_columns={"name"}
		, headers={'Imágenes'}
		, index_key="id"
		, columns_sizes={390}
		, list = nil
	}
	, music = {
		  visible_columns={"status", "name"}
		, headers={'', 'Música'}
		, index_key="id"
		, columns_sizes={24, 363}
		, list = nil
		, playing = -1
		, audioPaused = TRUE
		, titleBar = nil
		, volume   = nil
	}
	, web = {
		dialog = nil
	}
}

local initialUSBX = (Page_USB['width']/2 - (90*3)/2) + Page_USB['x']
local buttonH = 42
local buttonW = 98
local buttonSep = 7
local apps = {}

function createAppList()
	Page_USB.apps.list = list:new(PageMargin + PageBorder, PageMargin + PageBorder, PageW, PageH - buttonH, menuColorTable)
	list:setSelected(   Page_USB.apps.list, -1)
	list:setVisibleRows(Page_USB.apps.list, Page_USB.show_count);
	list:setCellWidths( Page_USB.apps.list, Page_USB.apps.columns_sizes);
	list:setCellHeaders(Page_USB.apps.list, Page_USB.apps.headers);
	wgt:setVisible(Page_USB.apps.list, FALSE)

	menupage:addChild(Page_USB.page, Page_USB.apps.list)
end

function createImageList()
	Page_USB.images.list = list:new(PageMargin + PageBorder, PageMargin + PageBorder, PageW, PageH - buttonH, menuColorTable)
	list:setSelected(   Page_USB.images.list, -1)
	list:setVisibleRows(Page_USB.images.list, Page_USB.show_count);
	list:setCellWidths( Page_USB.images.list, Page_USB.images.columns_sizes);
	list:setCellHeaders(Page_USB.images.list, Page_USB.images.headers);
	wgt:setVisible(Page_USB.images.list, FALSE)
	
	menupage:addChild(Page_USB.page, Page_USB.images.list)
end

function createImageViewer()
	Page_USB.image_viewer = imageviewer:new(0, 0, 720, 576, dialogZIndex, menuColorTable, {})
	imageviewer:exitCallback(Page_USB.image_viewer, "selectIndexInImageList")
	wgt:setVisible(Page_USB.image_viewer, FALSE)
end

function createMusicList()
	Page_USB.music.list = list:new(PageMargin + PageBorder, PageMargin + PageBorder, PageW, PageH - buttonH, menuColorTable)
	list:setSelected(   Page_USB.music.list, -1)
	list:setVisibleRows(Page_USB.music.list, Page_USB.show_count);
	list:setCellWidths( Page_USB.music.list, Page_USB.music.columns_sizes);
	list:setCellHeaders(Page_USB.music.list, Page_USB.music.headers);
	wgt:setVisible(Page_USB.music.list, FALSE)
	list:mapColumn(Page_USB.music.list, 0, "||", "img:PausaBlanco.png", "img:PausaNegro.png")
	list:mapColumn(Page_USB.music.list, 0, ">", "img:PlayBlanco.png", "img:PlayNegro.png")
	
	Page_USB.music.titleBar = window:new(PageMargin + PageBorder,PageMargin + PageBorder, 390, 22, menuZIndex, comboboxColorTable)
	Page_USB.music.volume   = label:new(357, 2, 30, 18, menuColorTable, "", 14, Alignment.vBottom_hRight, 3)
	local musicaL = label:new(  4, -2, 50, 22, menuColorTable, "Música", 14, Alignment.vTop_hLeft)
	local volumeL = label:new(300, -2, 50, 22, menuColorTable, "Volumen", 14, Alignment.vTop_hRight)
	window:addChild(Page_USB.music.titleBar, Page_USB.music.volume)
	window:addChild(Page_USB.music.titleBar, musicaL)
	window:addChild(Page_USB.music.titleBar, volumeL)

	wgt:setVisible(Page_USB.music.titleBar, FALSE)

	menupage:addChild(Page_USB.page, Page_USB.music.list)
	menupage:addChild(Page_USB.page, Page_USB.music.titleBar)
end

function createWebTab()
	Page_USB.web.dialog = window:new(PageMargin + PageBorder, PageMargin + PageBorder, PageW - 2*(PageMargin + PageBorder) - 1, PageH - 2*(PageMargin + PageBorder) - buttonH - 10, menuZIndex, menuColorTable)
	local textw = 350
	local text = textarea:new((PageW - 2*(PageMargin + PageBorder) - textw)/2, 70, textw, 120
							, menuColorTable
							, "Para poder utilizar este servicio debe tener una conexión a internet y un teclado USB.\n \n Presione OK para abrir el navegador."
							, 14, 5, 22, Alignment.vCenter_hLeft, PageBorder)
	window:addChild(Page_USB.web.dialog, text)
	menupage:addChild(Page_USB.page, Page_USB.web.dialog)
	wgt:setVisible(Page_USB.web.dialog, FALSE)
end


function Page_USB.create()
	Page_USB.page = menupage:new(0,0, PageW,PageH, 70, menuColorTable)
	menupage:setLabel(Page_USB.page, Page_USB.label);
	menupage:setIcons(Page_USB.page, Page_USB.selectedicon, Page_USB.disabledicon, Page_USB.icon)
	menupage:setHelp( Page_USB.page, Page_USB.help)

-- Lists
	createAppList()
	createImageList()
	createImageViewer()
	createMusicList()
	createWebTab()

	Page_USB.current_list = Page_USB.apps

-- Buttons
	Page_USB.button_set = buttonset:new(PageMargin + PageBorder, PageH - buttonH - PageMargin - PageBorder, PageW - 2*(PageMargin + PageBorder), buttonH, menuColorTable)
	buttonset:circular(Page_USB.button_set, TRUE)
	menupage:addChild(Page_USB.page, Page_USB.button_set)
	
	local btnApp = button:new(0, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnApp, "Aplicaciones")
	button:icon(     btnApp, "USB_Aplicaciones.png","USB_Aplicaciones.png", 24, 20)
	button:action(   btnApp, "okPressed")
	button:selectedCallback(btnApp, "appSelected")
	wgt:setHelp(     btnApp, "Muestra las aplicaciones.\nOK = Ejecutar seleccionado    EXIT = Menú ppal.    MENU = Salir")
	buttonset:addButton(Page_USB.button_set, btnApp)
	
	local btnImg = button:new(buttonW+buttonSep, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnImg, "Imágenes")
	button:icon(     btnImg, "USB_Imagenes.png","USB_Imagenes.png", 24, 20)
	button:action(   btnImg, "okPressed")
	button:selectedCallback(btnImg, "imgSelected")
	wgt:setHelp(     btnImg, "Muestra las imágenes del dispositivo USB.\nOK = Mostrar seleccionada    EXIT = Menú ppal.    MENU = Salir")
	buttonset:addButton(Page_USB.button_set, btnImg)

	Page_USB.music.btn = button:new(2*(buttonW+buttonSep), 0, buttonW, buttonH, menuColorTable)
	button:label(    Page_USB.music.btn, "Música")
	button:icon(     Page_USB.music.btn, "USB_Musica.png","USB_Musica.png", 24, 20)
	button:action(   Page_USB.music.btn, "okPressed")
	button:selectedCallback(Page_USB.music.btn, "musicSelected")
	wgt:setHelp(     Page_USB.music.btn, "Muestra la lista de MP3 del dispositivo USB.\nOK = Reproducir    EXIT = Menú ppal.    MENU = Salir")
	button:enable(Page_USB.music.btn, musicEnabled)
	buttonset:addButton(Page_USB.button_set, Page_USB.music.btn)

	local btnWeb = button:new(3*(buttonW+buttonSep), 0, buttonW, buttonH, menuColorTable)
	button:label(    btnWeb, "WEB")
	button:icon(     btnWeb, "2-USB_Web.png","2-USB_Web.png", 24, 20)
	button:action(   btnWeb, "wwwPressed")
	button:selectedCallback(btnWeb, "wwwSelected")
	wgt:setHelp(     btnWeb, "Permite navegar en la web.\nOK = Abre el navegador    EXIT = Menú ppal.    MENU = Salir")
	button:enable(btnWeb, browserEnabled)
	buttonset:addButton(Page_USB.button_set, btnWeb)

	return Page_USB.page
end

function Page_USB.currentHelp()
	if (menupage:isActive(Page_USB.page)==0) then
		return Page_USB.help
	else
		return wgt:getHelp(Page_USB.button_set)
	end
end

function Page_USB.processKeys(key)
	-- print('[lua] Page_USB.processKeys('.. key ..')')
	local ret = true
	
	if wgt:isVisible(Page_USB.image_viewer) == TRUE then
		--	If the image viewer is visible, it should handle the keys
		return wgt:processKey(Page_USB.image_viewer, key) == TRUE
	else
		if wgt:processKey(Page_USB.button_set, key) == 0 then
			if wgt:processKey(Page_USB.current_list.list, key) == FALSE then
				ret = pkey(Page_USB.current_list, key)
			elseif (Page_USB.current_list == Page_USB.music) and (wgt:isVisible(Page_USB.web.dialog) == FALSE) then
				-- mark titlebar to be repainted
				wgt:setVisible(Page_USB.music.titleBar, TRUE)
			end
		end
		MainMenu.updateHelp(Page_USB)
	end

	return ret
end

function okPressed() -- send by the 4 buttons, used by the list
	Page_USB.current_list.onOk()
end

function Page_USB.activate(b)
	if (b) then
		buttonset:setActiveButton(Page_USB.button_set, lastTab)
		menupage:setActive(Page_USB.page, TRUE)
		--showApplications()
		--hideImages()
		--hideMusic()
		Page_USB.select(b)
	else
		list:setSelected(Page_USB.current_list.list, -1)
		buttonset:setActiveButton(Page_USB.button_set, -1)
		menupage:setActive(Page_USB.page, FALSE)
	end
end

function Page_USB.select(b)
-- 	print('[lua] Page_USB.select')
	if (b) then
		if lastTab == TAB_APP then 
			showApplications()
			hideImages()
			hideMusic()
			hideWeb()
		elseif lastTab == TAB_IMG then
			hideApplications()
			showImages()
			hideMusic()
			hideWeb()
		elseif lastTab == TAB_MUSIC then
			hideApplications()
			hideImages()
			showMusic()
			hideWeb()
		elseif lastTab == TAB_WWW then
			hideApplications()
			hideImages()
			hideMusic()
			showWeb()
		end
	else
		--	Not viewing the usb page in the main menu, then should reset the last tab to applications' tab
		lastTab = TAB_APP
	end
end

function showList(aList, id, values)
	wgt:setVisible(Page_USB.current_list.list, FALSE)
	Page_USB.current_list = aList
	list:setValues(Page_USB.current_list.list, aList.visible_columns, id, values)
	if #values > 0 then
		list:setSelected(Page_USB.current_list.list, 0)
	else
		list:setSelected(Page_USB.current_list.list, -1)
	end
	wgt:setVisible(Page_USB.current_list.list, TRUE)
end

---- Applications ----

function appSelected(b)
	-- print('[lua] appSelected('.. b ..')')
	if (b == TRUE) then
		lastTab = TAB_APP
		showApplications()
		hideImages()
		hideMusic()
		hideWeb()
	end
end

function showApplications()
	apps = {}
	addApps(middleware.getApplications(), gingaExecute, apps)

	addApps(zmb_apps.list(true), zmb_apps.start, apps)

	showList(Page_USB.apps, Page_USB.apps.index_key, apps)
	
	if (middleware.isEnabled() == FALSE) then
		-- print('[lua] showApplications(), ginga disabled, no applications to show')
	else
		if menupage:isActive(Page_USB.page) == TRUE then
			local size = list:getRowCount(Page_USB.current_list.list)
			if size == 0 then
				list:setSelected(Page_USB.current_list.list, -1)
			else
				list:setSelected(Page_USB.current_list.list, 0)
			end
		else
			list:setSelected(Page_USB.current_list.list, -1)
		end
	end
end

function addApps(list, callback, apps)
	for _,file in pairs(list) do
		file.onExecute = callback
		table.insert( apps, file)
	end
end

function gingaExecute(id)
	middleware.runApplication(id)
end

function hideApplications()
	wgt:setVisible(Page_USB.apps.list, FALSE)
end

function Page_USB.apps.onOk()
	if (list:getRowCount(Page_USB.apps.list) > 0) then
		local app_id = list:getCurrentValue(Page_USB.apps.list)
		local select = list:selected(Page_USB.apps.list)
		ApplicationLaunching = true
		hideMainMenu()
		-- print('[lua] Page_USB.apps.onOk, running app with id '..app_id)

		apps[select + 1].onExecute(app_id)
	end
	return true
end


---- Images ----

function imgSelected(b)
	-- print('[lua] imgSelected('.. b ..')')
	if (b == TRUE) then
		lastTab = TAB_IMG
		hideApplications()
		showImages()
		hideMusic()
		hideWeb()
	end
end

function formatImagesList(list)
	local res = {}
	for i=1, #list do
		res[i] = list[i].path
	end
	return res
end

function showImages()
	-- print('[lua] showImages()')
    local imgs = player.getImageFiles()
	showList(Page_USB.images, Page_USB.images.index_key, imgs)
	imageviewer:images(Page_USB.image_viewer, formatImagesList(imgs))
end

function hideImages()
	wgt:setVisible(Page_USB.images.list, FALSE)
end

function Page_USB.images.onOk()
	if (list:getRowCount(Page_USB.images.list) > 0) then
		-- print('[lua] showing an image ')
		local ix = list:selected(Page_USB.images.list)
		imageviewer:selectedImage(Page_USB.image_viewer, ix)
		wgt:open(Page_USB.image_viewer)
	end
	return true
end

function selectIndexInImageList(ix)
	list:setSelected(   Page_USB.images.list, ix)
end

---- Music ----

function musicSelected(b)
	-- print('[lua] musicSelected('.. b ..')')
	if (b == TRUE) then
		lastTab = TAB_MUSIC
		hideApplications()
		hideImages()
		showMusic()
		hideWeb()
	else
		player.stopAudioFile()
	end
end	

function showMusic()
	-- print('[lua] showMusic()')
	Page_USB.music.songs = player.getAudioFiles()

	Page_USB.music.showVolume()
	wgt:setVisible(Page_USB.music.titleBar, TRUE)

	showList(Page_USB.music, Page_USB.music.index_key, Page_USB.music.songs)
end

function hideMusic()
	wgt:setVisible(Page_USB.music.list, FALSE)
	wgt:setVisible(Page_USB.music.titleBar, FALSE)
end

function Page_USB.music.play(index)
	Page_USB.music.audioPaused = FALSE
	Page_USB.music.playing = index
	local song = Page_USB.music.songs[index+1]
	song.status = ">"
	wgt:setHelp(Page_USB.music.btn, "Muestra la lista de MP3 del dispositivo USB.\nOK = Pausa    EXIT = Detener    MENU = Salir")
	player.playAudioFile(song.id)
	list:updateRow(Page_USB.music.list, index, Page_USB.music.visible_columns, Page_USB.music.index_key, song)
	wgt:setVisible(Page_USB.music.titleBar, TRUE)
end

function Page_USB.music.togglePause(index)
	local song = Page_USB.music.songs[index+1]
	Page_USB.music.audioPaused = (Page_USB.music.audioPaused + 1) % 2
	if Page_USB.music.audioPaused == TRUE then
		song.status = "||"
		wgt:setHelp(Page_USB.music.btn, "Muestra la lista de MP3 del dispositivo USB.\nOK = Reproducir    EXIT = Menú ppal.    MENU = Salir")
	else
		song.status = ">"
		wgt:setHelp(Page_USB.music.btn, "Muestra la lista de MP3 del dispositivo USB.\nOK = Pausa    EXIT = Detener    MENU = Salir")
	end
	player.pauseAudioFile(Page_USB.music.audioPaused)
	list:updateRow(Page_USB.music.list, index, Page_USB.music.visible_columns, Page_USB.music.index_key, song)
	wgt:setVisible(Page_USB.music.titleBar, TRUE)
end

function Page_USB.music.stop(index)
	local song = Page_USB.music.songs[index+1]
	song.status = ""
	wgt:setHelp(Page_USB.music.btn, "Muestra la lista de MP3 del dispositivo USB.\nOK = Reproducir    EXIT = Menú ppal.    MENU = Salir")
	player.stopAudioFile()
	list:updateRow(Page_USB.music.list, index, Page_USB.music.visible_columns, Page_USB.music.index_key, song)
	Page_USB.music.playing = -1
	wgt:setVisible(Page_USB.music.titleBar, TRUE)
end

function Page_USB.music.onOk()
	if (list:getRowCount(Page_USB.music.list) > 0) then
		local row_index = list:selected(Page_USB.music.list)
		if Page_USB.music.playing == -1 then
			Page_USB.music.play(row_index)
		elseif Page_USB.music.playing == row_index then
			Page_USB.music.togglePause(row_index)
		else
			Page_USB.music.stop(Page_USB.music.playing)
			Page_USB.music.play(row_index)
		end
	end
	return true
end

function Page_USB.music.onExit()
-- Stops the current song, if playing.
-- Otherwise, let the page handle the key
	if Page_USB.music.playing ~= -1 then
		Page_USB.music.stop(--[[list:selected(Page_USB.music.list)]] Page_USB.music.playing)
		return true
	end
	return false
end

function Page_USB.music.showVolume()
	label:setText(Page_USB.music.volume, player.getVolume())
end

function Page_USB.music.onVolUp()
	player.volumeUp()
	Page_USB.music.showVolume()
	return true
end

function Page_USB.music.onVolDown()
	player.volumeDown()
	Page_USB.music.showVolume()
	return true
end

function Page_USB.music.onMute()
	player.toggleMute()
	Page_USB.music.showVolume()
	return true
end

function audioFileEnd()
	-- print( "[lua] Audio file end." )
	Page_USB.music.stop(Page_USB.music.playing)
	view.refresh()
end

---- Web ----

function wwwSelected(b)
	-- print('[lua] wwwSelected('.. b ..')')
	if (b == TRUE) then
		lastTab = TAB_WWW
		hideApplications()
		hideImages()
		hideMusic()
		showWeb()
	end
end

function showWeb()
	wgt:setVisible(Page_USB.web.dialog, TRUE)
end

function hideWeb()
	wgt:setVisible(Page_USB.web.dialog, FALSE)
end

local X = 200
local Y = 200
local W = 385
local H = 165

local loadingBrowserDialog = alertdialog:new(X, Y, W, H, menuColorTable, dialogZIndex, 4)
alertdialog:title(loadingBrowserDialog, "ADVERTENCIA")
alertdialog:text(loadingBrowserDialog, "Cargando navegador...", 1)
alertdialog:icon(loadingBrowserDialog, "Confirmacion.png", 70, 61)

local loadingBrowserBackground = window:new(0,0, canvas_w,canvas_h, menuZIndex, menuColorTable)
wgt:setVisible(loadingBrowserBackground, FALSE)


function wwwPressed()
	-- print('[lua] wwwPressed(), opening browser...')
	wgt:open(loadingBrowserBackground)
	wgt:open(loadingBrowserDialog)
	view.refresh()
	mainWindow.launchBrowser()
end

