ParentalDialog = {
	  dlg = nil
	, nav = {
		name = "ParentalDialog"
	}
	, vertical_set = nil

	, ageCombo      = nil
	, violenceCombo = nil
	, sexCombo      = nil
	, drugsCombo    = nil
	, ages = {
		  [0] = 0x01 -- ATP
		, [1] = 0x06 -- +18
		, [2] = 0x05 -- +16
		, [3] = 0x04 -- +14
		, [4] = 0x03 -- +12
		, [5] = 0x02 -- +10
	}
	, ages_indices = {0,5,4,3,2,1}

	, violence = 0x20
	, sex      = 0x40
	, drugs    = 0x10

}

ParentalAge     = control.getParentalAge()
ParentalContent = control.getParentalContent()

local COMBO_FONT_SIZE = 15
local ITEMS_FONT_SIZE = 15
local ITEMS_W = 200
function makeParentalCombo(x, y, w, h, title, items)
	return combobox:new(x, y, w, h
                      , comboboxColorTable
                      , title, COMBO_FONT_SIZE
                      , items
                      , ITEMS_FONT_SIZE
                      , ITEMS_W)
end

function createParentalDialog()
--	print("[lua] createParentalDialog()")
	local x = 195
	local y = 137 - 30
	local width  = 432
	local height = 290
	local buttonW, buttonH = 90,36
	local buttonX = width/2
	local buttonY = 235
	local COMBO_X =  21 - 15
	local COMBO_Y =  26 - 35
	local COMBO_W = width - 2*(PageBorder+PageMargin)
	local COMBO_H =  26

	ParentalDialog.dlg = basicdialog:new(x,y, width,height, menuColorTable, dialogZIndex, PageBorder)
	basicdialog:title(ParentalDialog.dlg, "CONTROL PARENTAL")

	local ageTitle     = label:new(COMBO_X, COMBO_Y,                   200,26, menuColorTable, "Por edad", 15, Alignment.vBottom_hLeft)
	local contentTitle = label:new(COMBO_X, COMBO_Y + (COMBO_H + 5)*2, 200,26, menuColorTable, "Por contenidos", 15, Alignment.vBottom_hLeft)
	--basicdialog:addChild(ParentalDialog.dlg, ageTitle)
	--basicdialog:addChild(ParentalDialog.dlg, contentTitle)

	ParentalDialog.ageCombo      = makeParentalCombo(COMBO_X, COMBO_Y + (COMBO_H + 5)  , COMBO_W, COMBO_H, "Bloquear por edad",       {"No", "Para mayores de 18 años", "Para mayores de 16 años", "Para mayores de 14 años", "Para mayores de 12 años", "Para mayores de 10 años"})
	ParentalDialog.violenceCombo = makeParentalCombo(COMBO_X, COMBO_Y + (COMBO_H + 5)*3, COMBO_W, COMBO_H, "Contenidos de Violencia", {"Permitir","Bloquear"})
	ParentalDialog.sexCombo      = makeParentalCombo(COMBO_X, COMBO_Y + (COMBO_H + 5)*4, COMBO_W, COMBO_H, "Contenidos de Sexo",      {"Permitir","Bloquear"})
	ParentalDialog.drugsCombo    = makeParentalCombo(COMBO_X, COMBO_Y + (COMBO_H + 5)*5, COMBO_W, COMBO_H, "Contenidos de Drogas",    {"Permitir","Bloquear"})

	ParentalDialog.vertical_set = verticalset:new(15, 35, 412, 250, menuColorTable)
	verticalset:circular(ParentalDialog.vertical_set, TRUE)
	verticalset:addWidget(ParentalDialog.vertical_set, ParentalDialog.ageCombo)
	verticalset:addWidget(ParentalDialog.vertical_set, ParentalDialog.violenceCombo)
	verticalset:addWidget(ParentalDialog.vertical_set, ParentalDialog.sexCombo)
	verticalset:addWidget(ParentalDialog.vertical_set, ParentalDialog.drugsCombo)
	verticalset:addChild(ParentalDialog.vertical_set, ageTitle, FALSE)
	verticalset:addChild(ParentalDialog.vertical_set, contentTitle, FALSE)
	basicdialog:addChild(ParentalDialog.dlg, ParentalDialog.vertical_set)

	ParentalDialog.button_set = buttonset:newExtended(buttonX - buttonW - 5 - 15, buttonY - 35, 15 + 2 * buttonW, buttonH, menuColorTable)
	buttonset:circular(ParentalDialog.button_set, TRUE)

	local btnAceptar = button:new(0, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnAceptar, "ACEPTAR", 16)
	button:action(   btnAceptar, "acceptPressed")
	buttonset:addButton(ParentalDialog.button_set, btnAceptar)

	local btnCancelar = button:new(buttonW + 15, 0, buttonW, buttonH, menuColorTable)
	button:label(    btnCancelar, "CANCELAR", 16)
	button:action(   btnCancelar, "cancelPressed")
	buttonset:addButton(ParentalDialog.button_set, btnCancelar)
	
	verticalset:addWidget(ParentalDialog.vertical_set, ParentalDialog.button_set)
	verticalset:setActiveItem(ParentalDialog.vertical_set, 0)

	wgt:fixOffsets(ParentalDialog.dlg)
end

function ParentalDialog.open()
	-- print("[lua] ParentalDialog.open()")
	loadParentalControlValues()
	openDialog(ParentalDialog)
end

function ParentalDialog.nav.processKeys(key)
	-- print('[lua] ParentalDialog.processKeys('.. key ..')')
	local ret = true
	if wgt:processKey(ParentalDialog.vertical_set, key) == FALSE then
		ret = pkey(ParentalDialog, key)
	end
--
--	MainMenu.updateHelp(Page_Config)
--
	return ret
end

function ParentalDialog.onExit()
	-- print('[lua] ParentalDialog.onExit()')
	closeDialog(ParentalDialog)
	return true
end

function ParentalDialog.nav.acceptsFocus()
	return true
end

function cancelPressed()
	closeDialog(ParentalDialog)
end

function acceptPressed()
	if PINSet() then
		PINDlg.init("Por favor, ingrese la clave", dialogZIndex)
		PINDlg.open(doAccept, "pinClose")
	else
		openDialog(Page_Channels.pinRequired)
	end
end

function doAccept()
	-- print('[lua] acceptPressed')
	-- Parental Content
	ParentalContent = combobox:getSelected(ParentalDialog.violenceCombo)* ParentalDialog.violence
					+ combobox:getSelected(ParentalDialog.sexCombo)     * ParentalDialog.sex
					+ combobox:getSelected(ParentalDialog.drugsCombo)   * ParentalDialog.drugs
	control.setParentalContent(ParentalContent)

	-- Parental Age
	ParentalAge = ParentalDialog.ages[combobox:getSelected(ParentalDialog.ageCombo)]
	control.setParentalAge(ParentalAge)
	
	closeDialog(ParentalDialog)
end

function flagIndex(content)
	if (canvas:binary_and(ParentalContent, content) == content) then
		return 1
	else
		return 0
	end
end

function loadParentalControlValues()
	-- Parental Age
	combobox:setSelected(ParentalDialog.ageCombo,      ParentalDialog.ages_indices[ParentalAge])
	-- Parental Content
	combobox:setSelected(ParentalDialog.violenceCombo, flagIndex(ParentalDialog.violence))
	combobox:setSelected(ParentalDialog.sexCombo,      flagIndex(ParentalDialog.sex))
	combobox:setSelected(ParentalDialog.drugsCombo,    flagIndex(ParentalDialog.drugs))

	verticalset:setActiveItem(ParentalDialog.vertical_set, 0)
end

