PINLength = 4
typedPIN = ""

--function isPINComplete(p)
--	return #p == PINLength
--end

function PINSet()
	return control.isSet() == 1
end

function isInRange(number)
	return number >= 0 and number <=9
end

local dw = 385
local dh = 145
local dx = 217
local dy = 167


PINDlg = {
	  nav = { name = 'PIN' }
	, callback = nil
	, opened = false
}

function PINDlg.init(promptText, zIndex)
	PINDlg.dlg = pindialog:new(dx,dy, dw,dh, menuColorTable, zIndex, 4)
	pindialog:title( PINDlg.dlg, "CLAVE" )
	pindialog:prompt( PINDlg.dlg, promptText )
	pindialog:icon( PINDlg.dlg, "Clave.png", 70,61, "Clave_Gris.png" )
	pindialog:help( PINDlg.dlg, "(EXIT = cancelar)" )
end

function PINDlg.nav.processKeys(key)
	if isInRange(key - 1) then
		typedPIN = typedPIN .. ( key - 1 )
	end
	if PINLength == string.len( typedPIN ) then
		if control.checkPIN( typedPIN ) then
			pindialog:pinCorrect(PINDlg.dlg)
		else
			pindialog:pinIncorrect(PINDlg.dlg)
			typedPIN = ""
		end
	end
	return wgt:processKey(PINDlg.dlg, key)
end

function PINDlg.nav.acceptsFocus()
	return true
end

function PINDlg.open(okCbk, cancelCbk)
	PINDlg.callback = okCbk
	typedPIN = ""
	if control.isSessionOpened() == 1 then
		if PINDlg.callback ~= nil then
			PINDlg.callback()
		end
	else
		PINDlg.opened = true
		pindialog:callbacks(PINDlg.dlg, "onClosePINdialog", cancelCbk)
		pindialog:open(PINDlg.dlg, PINLength)
		pushCurrentWindow(PINDlg.nav)
		view.refresh()
		lockKeys()
	end
end

function pinClose()
	pindialog:callbacks(PINDlg.dlg, "", "") -- keep it clean for future uses
	removeWindow('PIN')
	PINDlg.opened = false
	unlockKeys()
end

function PINDlg.acceptsFocus()
	return true
end

function onClosePINdialog()
	print('[lua] onClosePINdialog(), authenticated=true')
	pinClose()
	if PINDlg.callback ~= nil then
		PINDlg.callback()
	end
end


