local VolumeVisible = false

local Bar = progressbar:new(180,412,360,24, widgetZIndex, 0,0,player.maxVolume(), colorTableBar, "Volumen")
wgt:setVisible(Bar, FALSE)

local MUTE_X, MUTE_Y, MUTE_W, MUTE_H = 72, 57, 47, 38
local mute = image:new(MUTE_X, MUTE_Y, MUTE_W, MUTE_H, muteZIndex, menuColorTable, "Mute.png")
wgt:setVisible(mute, FALSE)

function renderVolume()
	-- print("[lua] renderVolume.....................")
	local barW, barH = 400,26
      
  	if(not VolumeVisible) then
		openVolumeNav()
  	end
	local value = player.getVolume()
	progressbar:setValue(Bar, value)

	wgt:open(Bar)

	VolumeVisible = true
	local tID = mainWindow.registerTimer(Timers['volume']['timeout'])
	Timers['volume']['id'] = tID
end

local MuteVisible = false

function clearMute()
	-- print('[lua] clearMute()...............')
	if MuteVisible then
		MuteVisible = false
		closeMuteNav()
		wgt:close(mute)
	end
end

function renderMute( isMuted )
	-- print("[lua] renderMute.............")
	if isMuted == TRUE then
		MuteVisible = true
		openMuteNav()
		wgt:open(mute)
	else
		clearMute()
		renderVolume()
	end
end

function clearVolume()
	if (VolumeVisible) then
		wgt:close(Bar)
		mainWindow.cancelTimer(Timers.volume.id)
		Timers['volume']['id'] = -1
		VolumeVisible = false
		closeVolumeNav()
	end
end

function toggleMute()
	clearVolume()
	renderMute( player.toggleMute() )
end

function volumeUp()
	if (VolumeVisible) then
		player.volumeUp()
		renderVolume()
	elseif (player.isMuted() == 1) then
		toggleMute()
	else
		renderVolume()
	end
end

function volumeDown()
	if (VolumeVisible) then
		player.volumeDown()
		renderVolume()
	elseif (player.isMuted() == 1) then
		toggleMute()
	else
		renderVolume()
	end
end

function isVolumeVisible()
	return VolumeVisible
end

-----------------------------------------------------------------------------------

VolumeNav = {
	  name = "VolumeNav"
	, close = clearVolume
}

function VolumeNav.processKeys(key)
	-- print('[lua] VolumeNav.processKeys('.. key ..')')
	return pkey(VolumeNav, key)
end

function VolumeNav.onVolUp()
	volumeUp()
	return true
end

function VolumeNav.onVolDown()
	volumeDown()
	return true
end


function VolumeNav.onDown()
	if canOpenZambaWidget() then
		closeCurrentWindow()
		channelDown( true )
	end
	return true
end

function VolumeNav.onUp()
	if canOpenZambaWidget() then
		closeCurrentWindow()
		channelUp( true )
	end
	return true
end

function VolumeNav.acceptsFocus()
	return false
end

function openVolumeNav()
	-- print('[lua] openVolumeNav()')
	pushCurrentWindow(VolumeNav)
end

function closeVolumeNav()
	-- print('[lua] closeVolumeNav()')
	removeWindow('VolumeNav')
end

-----------------------------------------------------------------------------------

MuteNav = {
	  name = "MuteNav"
	, close = clearMute
}

function MuteNav.processKeys(key)
	return pkey(MuteNav, key)
end

function MuteNav.onVolUp()
	volumeUp()
	return true
end

function MuteNav.onVolDown()
	volumeDown()
	return true
end

function MuteNav.onMute()
	toggleMute()
	return true
end

function MuteNav.acceptsFocus()
	return false
end

function openMuteNav()
	-- print('[lua] openMuteNav()')
	pushCurrentWindow(MuteNav)
end

function closeMuteNav()
	-- print('[lua] closeMuteNav()')
	removeWindow('MuteNav')
end
