
local manager = nil
local enable = false

local apps_view = nil

local M = {}

M.window = {}

function M.enable( bool )
	enable = bool
	if enable then
		require "applicationmanager"
		manager = appmanagerNew()
	end
end

function M.run()
	if manager ~= nil then
		appmanagerRun(manager)
	end
end

function M.fin()
	if manager ~= nil then
		appmanagerFinalize(manager)
	end
end

function M.onKeyEvent( key, isUp )
	if manager ~= nil then
		local evt = {type="key", value=key, isUp=isUp}
		return appmanagerDispatchEvent(manager, evt)
	end
	return false
end

function M.dispatchEvent( evt )
	if manager ~= nil then
		appmanagerDispatchEvent(manager, evt)
	end
end

function M.list( interactive )
	local result = {}
	if manager ~= nil then
		result = appmanagerList(manager, interactive)
	end
	return result
end

function M.start( appid )
	if manager ~= nil then
		appmanagerStartApp(manager, appid)
	end
end

function M.openAppsList()
	if apps_view == nil then
		apps_view = require "apps_list"
	end
	apps_view.openAppsList()
end

function M.restore()
	if manager ~= nil then
		appmanagerDisableAll(manager)
	end
end

function M.enabled()
	return enable and TRUE or FALSE
end

function M.window.acceptsFocus()
	return true
end

return M